CREATE TABLE  "CURRENCY" 
   (	"CURRENCY" VARCHAR2(20) NOT NULL ENABLE, 
	 CONSTRAINT "COURRENCY_PK" PRIMARY KEY ("CURRENCY") ENABLE
   )
/

CREATE TABLE  "COUNTRIES" 
   (	"CODECOUNTRY" CHAR(2) CONSTRAINT "COUNTRY_ID_NN" NOT NULL ENABLE, 
	"COUNTRY_NAME" VARCHAR2(40), 
	"CURRENCY" VARCHAR2(20), 
	 CONSTRAINT "COUNTRIES_PK" PRIMARY KEY ("CODECOUNTRY") ENABLE, 
	 CONSTRAINT "COUNTRIES_FK" FOREIGN KEY ("CURRENCY")
	  REFERENCES  "CURRENCY" ("CURRENCY") ENABLE
   ) ORGANIZATION INDEX NOCOMPRESS
/

CREATE TABLE  "TELEPHONEOP" 
   (	"CIFTELEPHONEOP" VARCHAR2(20) NOT NULL ENABLE, 
   "NAMETELEPHONEOP" VARCHAR2(20) NOT NULL ENABLE,
	"NAMEGLOBALOP" VARCHAR2(40) NOT NULL ENABLE, 
	 CONSTRAINT "TELEPHONEOP_PK" PRIMARY KEY ("CIFTELEPHONEOP") ENABLE
   )
/

CREATE TABLE  "OSYSTEM" 
   (	"NAMEOS" VARCHAR2(20) NOT NULL ENABLE, 
	 CONSTRAINT "OSYSTEM_PK" PRIMARY KEY ("NAMEOS") ENABLE
   )
/


CREATE TABLE  "DEVICEMODEL" 
   (	"DEVICEMODEL" VARCHAR2(20) NOT NULL ENABLE, 
	"MANUFACTURER" VARCHAR2(20), 
	 CONSTRAINT "DEVICEMODEL_PK" PRIMARY KEY ("DEVICEMODEL") ENABLE
   )
/


  CREATE TABLE  "USERS" 
   (	"IDCARD" VARCHAR2(20) NOT NULL ENABLE, 
	"NAMEUSER" VARCHAR2(20) NOT NULL ENABLE, 
	"SURNAMEUSER" VARCHAR2(30) NOT NULL ENABLE, 
	"DATEBIRTH" DATE NOT NULL ENABLE, 
	"MOBILENUMBER" NUMBER(15,0) NOT NULL ENABLE, 
	"CIFTELEPHONEOP" VARCHAR2(20) NOT NULL ENABLE, 
	"CODECOUNTRY" CHAR(2) NOT NULL ENABLE, 
	"MAIL" VARCHAR2(20) NOT NULL ENABLE, 
	"DATEINSERT" DATE NOT NULL ENABLE, 
	"DATEDELETE" DATE, 
	 CONSTRAINT "USERS_PK" PRIMARY KEY ("IDCARD") ENABLE, 
	 CONSTRAINT "USERS_FK" FOREIGN KEY ("CIFTELEPHONEOP")
	  REFERENCES  "TELEPHONEOP" ("CIFTELEPHONEOP") ENABLE, 
	 CONSTRAINT "USERS_FK2" FOREIGN KEY ("CODECOUNTRY")
	  REFERENCES  "COUNTRIES" ("CODECOUNTRY") ENABLE
   )
/

CREATE TABLE  "DEVICE" 
   (	"IMEI" NUMBER(15,0) NOT NULL ENABLE, 
	"IDCARDUSER" VARCHAR2(20) NOT NULL ENABLE, 
	"DEVICEMODEL" VARCHAR2(20) NOT NULL ENABLE, 
	 CONSTRAINT "DEVICE_PK" PRIMARY KEY ("IMEI") ENABLE, 
	 CONSTRAINT "DEVICE_FK" FOREIGN KEY ("IDCARDUSER")
	  REFERENCES  "USERS" ("IDCARD") ENABLE, 
	 CONSTRAINT "DEVICE_FK2" FOREIGN KEY ("DEVICEMODEL")
	  REFERENCES  "DEVICEMODEL" ("DEVICEMODEL") ENABLE
   )
/


CREATE TABLE  "DEVELOPERS" 
   (	"DEVELOPERID" VARCHAR2(15) NOT NULL ENABLE, 
	"NAMECOMP" VARCHAR2(30) NOT NULL ENABLE, 
	"NAMELEGALREPRES" VARCHAR2(20) NOT NULL ENABLE, 
	"SURNAMELEGALREPRES" VARCHAR2(30) NOT NULL ENABLE, 
	"IDCARDREPRES" VARCHAR2(15) NOT NULL ENABLE, 
	"COUNTRYCODE" CHAR(2) NOT NULL ENABLE, 
	"HEADOFFICEADDRESS" VARCHAR2(60) NOT NULL ENABLE, 
	"HEADOFFICECITY" VARCHAR2(20) NOT NULL ENABLE, 
	"HEADOFFICECP" NUMBER(7,0) NOT NULL ENABLE, 
	"HEADOFFICEPROVINCE" VARCHAR2(20) NOT NULL ENABLE, 
	"TELEPHONE1" NUMBER(15,0) NOT NULL ENABLE, 
	"TELEPHONE2" NUMBER(15,0), 
	"EMAIL" NVARCHAR2(80) NOT NULL ENABLE, 
	"DATEINSERT" DATE NOT NULL ENABLE, 
	"DATEDELETE" DATE, 
	 CONSTRAINT "DEVELOPERS_PK" PRIMARY KEY ("DEVELOPERID") ENABLE, 
	 CONSTRAINT "DEVELOPERS_FK" FOREIGN KEY ("COUNTRYCODE")
	  REFERENCES  "COUNTRIES" ("CODECOUNTRY") ENABLE
   )
/

CREATE TABLE  "APP" 
   (	"APPIDENTIF" VARCHAR2(20) NOT NULL ENABLE, 
	 CONSTRAINT "APP_PK" PRIMARY KEY ("APPIDENTIF") ENABLE
   )
/

CREATE TABLE  "APP_OS" 
   (	"APPIDENTIF" VARCHAR2(20) NOT NULL ENABLE, 
	"NAMEOS" VARCHAR2(20) NOT NULL ENABLE, 
	 CONSTRAINT "APP_OS_PK" PRIMARY KEY ("APPIDENTIF", "NAMEOS") ENABLE, 
	 CONSTRAINT "APP_OS_FK" FOREIGN KEY ("APPIDENTIF")
	  REFERENCES  "APP" ("APPIDENTIF") ENABLE
   )
/

CREATE TABLE  "APPLICATIONS" 
   (	"APPIDENTIF" VARCHAR2(20) NOT NULL ENABLE, 
	"VERSIONAPP" VARCHAR2(10) NOT NULL ENABLE, 
	"NAMEOS" VARCHAR2(20) NOT NULL ENABLE, 
	"DATEUP" TIMESTAMP (6) NOT NULL ENABLE, 
	"MINRESOSCREEN" VARCHAR2(10) NOT NULL ENABLE, 
	"SIZEAPP" NUMBER(9,2) NOT NULL ENABLE, 
	"LINKAPP" VARCHAR2(60) NOT NULL ENABLE, 
	"ACTIVE" VARCHAR2(1) NOT NULL ENABLE, 
	"DATEDELETE" DATE, 
	 CONSTRAINT "APPLICATIONS_PK" PRIMARY KEY ("APPIDENTIF", "VERSIONAPP", "NAMEOS") ENABLE, 
	 CONSTRAINT "APPLICATIONS_FK" FOREIGN KEY ("APPIDENTIF", "NAMEOS")
	  REFERENCES  "APP_OS" ("APPIDENTIF", "NAMEOS") ENABLE
   )
/

CREATE TABLE  "APPDESCRIPTION" 
   (	"APPIDENTIF" VARCHAR2(20) NOT NULL ENABLE, 
	"LANGUAGEDES" VARCHAR2(15) NOT NULL ENABLE, 
	"DESCRIPTION" VARCHAR2(4000) NOT NULL ENABLE, 
	 CONSTRAINT "APPDESCRIPTION_PK" PRIMARY KEY ("APPIDENTIF", "LANGUAGEDES") ENABLE, 
	 CONSTRAINT "APPDESCRIPTION_FK" FOREIGN KEY ("APPIDENTIF")
	  REFERENCES  "APP" ("APPIDENTIF") ENABLE
   )
/

CREATE TABLE  "APPURLVIDEO" 
   (	"APPIDENTIF" VARCHAR2(20) NOT NULL ENABLE, 
	"NAMEOS" VARCHAR2(20) NOT NULL ENABLE, 
	"LANGUAGEURL" VARCHAR2(10) NOT NULL ENABLE, 
	"URLVIDEO" VARCHAR2(100) NOT NULL ENABLE, 
	 CONSTRAINT "APPURLVIDEO_PK" PRIMARY KEY ("APPIDENTIF", "NAMEOS", "LANGUAGEURL") ENABLE, 
	 CONSTRAINT "APPURLVIDEO_FK" FOREIGN KEY ("NAMEOS")
	  REFERENCES  "OSYSTEM" ("NAMEOS") ENABLE, 
	 CONSTRAINT "APPURLVIDEO_FK2" FOREIGN KEY ("APPIDENTIF", "NAMEOS")
	  REFERENCES  "APP_OS" ("APPIDENTIF", "NAMEOS") ENABLE
   )
/


CREATE TABLE  "APPDEVELOPE" 
   (	"APPIDENTIF" VARCHAR2(20) NOT NULL ENABLE, 
	"VERSIONAPP" VARCHAR2(10) NOT NULL ENABLE, 
	"NAMEOS" VARCHAR2(20) NOT NULL ENABLE, 
	"DEVELOPERID" VARCHAR2(15) NOT NULL ENABLE, 
	 CONSTRAINT "APPDEVELOPE_PK" PRIMARY KEY ("APPIDENTIF", "VERSIONAPP", "NAMEOS", "DEVELOPERID") ENABLE, 
	 CONSTRAINT "APPDEVELOPE_FK1" FOREIGN KEY ("DEVELOPERID")
	  REFERENCES  "DEVELOPERS" ("DEVELOPERID") ENABLE, 
	 CONSTRAINT "APPDEVELOPE_FK2" FOREIGN KEY ("APPIDENTIF", "VERSIONAPP", "NAMEOS")
	  REFERENCES  "APPLICATIONS" ("APPIDENTIF", "VERSIONAPP", "NAMEOS") ENABLE
   )
/
CREATE TABLE  "PRICE" 
   (	"APPIDENTIF" VARCHAR2(20) NOT NULL ENABLE, 
	"VERSIONAPP" VARCHAR2(10) NOT NULL ENABLE, 
	"NAMEOS" VARCHAR2(20) NOT NULL ENABLE, 
	"CODECOUNTRY" CHAR(2) NOT NULL ENABLE, 
	"PRICE" NUMBER(6,2) NOT NULL ENABLE, 
   CONSTRAINT "PRICE_PK" PRIMARY KEY ("APPIDENTIF","VERSIONAPP","NAMEOS","CODECOUNTRY") ENABLE,
	 CONSTRAINT "PRICE_FK" FOREIGN KEY ("CODECOUNTRY")
	  REFERENCES  "COUNTRIES" ("CODECOUNTRY") ENABLE,
   CONSTRAINT "PRICE_FK2" FOREIGN KEY ("APPIDENTIF","VERSIONAPP", "NAMEOS")
    REFERENCES "APPLICATIONS" ("APPIDENTIF","VERSIONAPP", "NAMEOS") ENABLE
   )
/

CREATE TABLE  "DOWNLOADS" 
   (	"APPIDENTIF" VARCHAR2(20), 
	"VERSIONAPP" VARCHAR2(10), 
	"NAMEOS" VARCHAR2(20), 
	"IDCARDUSER" VARCHAR2(15), 
	"DATEDOWN" TIMESTAMP (6), 
	"PAYWAY" VARCHAR2(15), 
	"PRICE" NUMBER(6,2), 
	"CODECOUNTRY" CHAR(2), 
	"IMEI" NUMBER(15,0), 
	"IDTELEPHONEOP" VARCHAR2(20), 
	 CONSTRAINT "DOWNLOADS_FK" FOREIGN KEY ("IDCARDUSER")
	  REFERENCES  "USERS" ("IDCARD") ENABLE, 
	 CONSTRAINT "DOWNLOADS_FK2" FOREIGN KEY ("APPIDENTIF","VERSIONAPP","NAMEOS")
	  REFERENCES  "APPLICATIONS" ("APPIDENTIF","VERSIONAPP","NAMEOS") ENABLE 
  )
/


CREATE TABLE  "LOGS" 
   (	"NAMEPROCEDURE" VARCHAR2(80) NOT NULL ENABLE, 
	"PARAMIN" VARCHAR2(4000) NOT NULL ENABLE, 
	"RESULTPR" VARCHAR2(4000) NOT NULL ENABLE, 
	"DATATIME" TIMESTAMP (6)
   )
/



  CREATE TABLE  "ES_TOTAL" 
   (	"TOTALDOWNLOADS" NUMBER DEFAULT 0 NOT NULL ENABLE, 
	"TOTALEUROS" NUMBER(15,2) DEFAULT 0 NOT NULL ENABLE
   )
/

 CREATE TABLE  "ES_YEAR" 
   (	"EYEAR" NUMBER(4,0) NOT NULL ENABLE, 
	"USERSNUM" NUMBER DEFAULT 0, 
	"APPNUM" NUMBER DEFAULT 0, 
	"MEDIADOWNUSERS" NUMBER(6,2) DEFAULT 0, 
	"TOPDEVELOPER" VARCHAR2(20), 
	"DEVELOPEDOWNNUM" NUMBER, 
	"TOPAPP" VARCHAR2(20), 
	"TOPAPPDEVELOPER" VARCHAR2(60), 
	"TOPAPPVERSION" VARCHAR2(10), 
	"TOPAPPOS" VARCHAR2(20), 
	 CONSTRAINT "ES_YEAR_PK" PRIMARY KEY ("EYEAR") ENABLE
   )
/


CREATE TABLE  "ES_YEARCOUNTRY" 
   ("EYEAR" NUMBER(4,0) NOT NULL ENABLE, 
	"COUNTRY" CHAR(2) NOT NULL ENABLE, 
	"MINUSERSNUM" NUMBER, 
	"TOTALINCOME" NUMBER(9,2) DEFAULT 0, 
	"APPDIFDOWNNUM" NUMBER DEFAULT 0, 
	 CONSTRAINT "ES_YEARCOUNTRY_PK" PRIMARY KEY ("EYEAR", "COUNTRY") ENABLE
   )
/

-------------------------------------------------------------------------
-- PROCEDIMIENTO PARA REGISTRAR LA EJECUCIN DE TODOS LOS PROCEDIMIENTOS
-- DATOS DE ENTRADA:
--    NAMEPROCEDURE
--    PARAMIN
--  DATOS DE SALIDA:
--    RESILTPR (RSP)
--------------------------------------------------------------------------
create or replace
PROCEDURE pr_insert_logs(
	PnameProcedure IN logs.nameprocedure%TYPE, 
	Pparamin IN logs.paramin%TYPE,
	Presultpr IN logs.resultpr%TYPE
	)
AS
  vdatatime date;
BEGIN
	vdatatime := SYSDATE ;
	INSERT INTO Logs (nameprocedure, paramin, resultpr,datatime)
      	VALUES (PnameProcedure, Pparamin, Presultpr,vdatatime); 
END pr_insert_logs;
/

--------------------------------------------------
-- ALTA, BAJA O MODIFICACIN DE DISPOSITIVOS
-- DATOS DE ENTRADA
--	ACTION ('A','B' o 'M')
--	IMEI del dispositivo
--	MODELO DEL DISPOSITIVO
--------------------------------------------------
create or replace
procedure pr_abm_devices 
(
    Paction in char,
    PidCardU in users.idcard%TYPE,
    Pimei in device.imei%TYPE,
    PdeviceModel in device.devicemodel%TYPE,
    resultpr out nocopy varchar2
)as 
-- DECLARACIN DE VARIABLES
  
  noAction EXCEPTION;  
  noIdCard EXCEPTION;
  noImei EXCEPTION;
  imeiNoValid EXCEPTION;
  imeiNoExist EXCEPTION;
  noDeviceModel EXCEPTION;
  noMinDevice EXCEPTION;
  err_num        NUMBER;
  err_msg        VARCHAR2(3500);
  
  aux number;
  aux2 number;
    paramin logs.paramin%type;
    nameprocedure logs.nameprocedure%type;
  
begin
--INICIALIZACIN DE VARIABLES
  resultpr := 'Ok';
  paramin := '<'|| Paction ||'><'|| PidCardU ||'><'|| pimei ||'><'|| pdevicemodel ||'>';
  nameprocedure := 'pr_abm_devices';
             
   -- COMPROBACIN DE PARMETROS DE ENTRADA
  IF (Paction IS NULL OR Paction ='') THEN
    RAISE noAction;
  END IF;
  IF (PidCardU IS NULL OR PidCardU = '') THEN
    RAISE noIdCard;
  END IF;
  
  IF (Pimei IS NULL OR Pimei = 0) THEN
    RAISE noImei;
  END IF;
  --- comprueba que sea un imei vlido (15 dgitos)
  IF ((length(Pimei)<>15)) THEN
    RAISE imeiNoValid;
  END IF;
  
  --- en el caso de un alta o modificacin tiene que existir el modelo del dispositivo (para baja no es necesario)
  IF (Paction = 'A' OR Paction ='M') THEN
    IF (PdeviceModel IS NULL OR PdeviceModel = '') THEN
      RAISE noDeviceModel;
    END IF;
  END IF;
    
  
  SELECT COUNT(*) INTO aux FROM device WHERE imei = Pimei;
  -- Alta dispositivo
  IF (Paction = 'A' OR Paction = 'a') THEN
    --- Si el dispositivo no est dado de alta se inserta, si ya est dado de alta
    --- se cambia el usuario al que pertenece
    
    IF (aux=1)  THEN
      update device  set idCardUser = PidCardU where imei=Pimei;
    ELSE 
      insert into device 
      (
        imei,
        idCardUser,
        deviceModel)
      values
      (
        Pimei,
        PidCardU,
        PdeviceModel);
    END IF;
    -- Inserccin correcta del nuevo usuario
    pr_insert_logs (nameprocedure, paramin, resultpr); 
ELSE IF (Paction = 'B' OR Paction = 'b') THEN
        --Baja de Dispositivo. Si el dispositivo est dado de alta se borra,
        --sino se notifica error.
        IF (aux =1) THEN
        -- Comprobamos que no quede solo un dispositivo, si se borra se incumplira la
        -- restriccin de que tiene que tener uno como mnimo.
        SELECT COUNT(*) INTO aux2 FROM device WHERE idCardUser = PidCardU;
          IF (aux2 > 1 ) THEN
              DELETE FROM device WHERE imei = Pimei;
          ELSE
            RAISE noMinDevice;
          END IF;
        ELSE 
                RAISE imeiNoExist;
        END IF;
     ELSE IF (Paction = 'M' OR Paction = 'm') THEN
          --Modificacin idCardUser o DeviceModel. Si existe se modifica, 
          --sino se notifica error
            IF (aux =1) THEN
              UPDATE device SET idcarduser = PidCardU, devicemodel = pdevicemodel
                WHERE imei = Pimei;
            ELSE 
              RAISE imeiNoExist;
            END IF;
          ELSE 
             RAISE noAction;
          END IF;
   END IF;  
END IF;
  -- CONTROL DE EXCEPCIONES
EXCEPTION
WHEN noIdCard THEN
  resultpr := 'ERROR: debe introducir un nmero de identidad';
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noImei THEN
  resultpr := 'ERROR: debe introducir el nmero imei de su dispositivo';   
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN imeiNoValid THEN
  resultpr := 'ERROR: nmero imei del dispositivo no vlido';   
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN imeiNoExist THEN
  resultpr := 'ERROR: No existe el nmero imei';   
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noDeviceModel THEN
  resultpr := 'ERROR: debe introducir el modelo de dispositivo';   
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN  noAction THEN
  resultpr := 'ERROR: accin a realizar no vlida';   
  pr_insert_logs (nameprocedure, paramin, resultpr); 
WHEN  noMinDevice THEN
  resultpr := 'ERROR: no se puede borrar, debe tener 1 dispositivo mnimo';   
  pr_insert_logs (nameprocedure, paramin, resultpr); 
WHEN OTHERS THEN
  err_num:= SQLCODE;
  err_msg := substr(SQLERRM, 1, 200);
  resultpr := 'ERROR: '|| TO_CHAR (err_num) || err_msg;
  pr_insert_logs (nameprocedure, paramin, resultpr);


end pr_abm_devices;
/

--------------------------------------------------
-- ALTA, BAJA O MODIFICACIN DE DESCRIPCIONES
-- DATOS DE ENTRADA
--	ACTION ('A','B' o 'M')
--	APPIDENTIF
--  APPLANGUAGESDES
--  APPDESCRIPTION
--DATOS DE SALIDA
--  RESULTPR (RSP)
--------------------------------------------------
create or replace
procedure pr_abm_descriptions 
(
    Paction in char,
    PappIdentif in appdescription.appIdentif%type,
    PappLanguageDes in appdescription.languagedes%type,
    PDescription in appdescription.description%TYPE,
    resultpr out nocopy varchar2
)as 
-- DECLARACIN DE VARIABLES
  
  noAction EXCEPTION;  
  noAppIdentif EXCEPTION;
  noAppLanguagesDes EXCEPTION;
  noAppDescription EXCEPTION;
  descriptionExist EXCEPTION;
  descriptionNoExist EXCEPTION;
  noMinDes EXCEPTION;
  noAppInsert EXCEPTION;
  err_num        NUMBER;
  err_msg        VARCHAR2(3500);
  
    aux number;
    aux2 number;
    paramin logs.paramin%type;
    nameprocedure logs.nameprocedure%type;
  
begin
--INICIALIZACIN DE VARIABLES
  resultpr := 'Ok';
  paramin := '<'|| Paction ||'><'|| PappIdentif ||'><'|| PappLanguageDes ||'><'|| PDescription ||'>';
  nameprocedure := 'pr_abm_descriptions';
             
   -- COMPROBACIN DE PARMETROS DE ENTRADA
  IF (Paction IS NULL OR Paction ='') THEN
    RAISE noAction;
  END IF;
  IF (PappIdentif IS NULL OR PappIdentif = '') THEN
    RAISE noAppIdentif;
  END IF;
  
  IF (PappLanguageDes IS NULL OR PappLanguageDes = '') THEN
    RAISE noAppLanguagesDes;
  END IF;
  
  --- en el caso de un alta o modificacin tiene que existir la descripcin (para baja no es necesario)
  IF (Paction = 'A' OR Paction ='M') THEN
    IF (PDescription IS NULL OR PDescription = '') THEN
      RAISE noAppDescription;
    END IF;
  END IF;
  
  SELECT COUNT(*) INTO aux FROM appDescription WHERE appIdentif = PappIdentif AND languagedes = papplanguagedes;
  SELECT COUNT(*) INTO aux2 FROM applications WHERE appidentif=PappIdentif AND datedelete is null;
   
   -- Alta descripcin
  IF (Paction = 'A' OR Paction = 'a') THEN
    --- Si la descripcin no est dado de alta y existe la aplicacin se inserta, si ya est dado de alta
    --- devuelve mensaje de error.
    --- Si no existe aplicacion dada de alta notifica error 
    
    IF (aux=0)  THEN
       IF (aux2 >0) THEN
        INSERT INTO appdescription (appidentif, languagedes, description)
                  VALUES (PappIdentif, papplanguageDes, pdescription);
      ELSE
        RAISE noAppInsert;
      END IF;
    ELSE 
      RAISE descriptionExist;
    END IF;
    -- Inserccin correcta de la descripcin
    pr_insert_logs (nameprocedure, paramin, resultpr); 
ELSE IF (Paction = 'B' OR Paction = 'b') THEN
        --Baja de la descripcin. Si la descripcin est dado de alta se borra,
        --sino se notifica error.
      -- Comprobamos que no exista solo 1 descripcin, ya que como mn. tiene que haber una
        IF (aux =1) THEN
          SELECT COUNT(*) INTO aux2 FROM appdescription WHERE appIdentif = PappIdentif;
          IF (aux2 >1) THEN
            DELETE FROM appdescription WHERE appIdentif = PappIdentif AND languagedes = papplanguagedes;
          ELSE
            RAISE noMinDes;
          END IF;
        ELSE 
                RAISE descriptionNoExist;
        END IF;
            -- Borrado correcto de la descripcin
            pr_insert_logs (nameprocedure, paramin, resultpr);
     ELSE IF (Paction = 'M' OR Paction = 'm') THEN
          --Modificacin de la descripcin. Si existe se modifica, 
          --sino se notifica error
            IF (aux =1) THEN
              UPDATE appdescription SET description = pdescription
                WHERE appIdentif = PappIdentif AND languagedes = papplanguagedes;
                -- Modificacin correcta de la descripcin
                 pr_insert_logs (nameprocedure, paramin, resultpr);
            ELSE 
              RAISE descriptionNoExist;
            END IF;
          ELSE 
             RAISE noAction;
          END IF;
   END IF;  
END IF;
  -- CONTROL DE EXCEPCIONES
EXCEPTION
WHEN noAppIdentif THEN
  resultpr := 'ERROR: debe introducir una aplicacin';
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noAppLanguagesDes THEN
  resultpr := 'ERROR: debe introducir el idioma de la descripcin';   
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noAppDescription THEN
  resultpr := 'ERROR: debe introducir la descripcin';   
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN descriptionExist THEN
  resultpr := 'ERROR: La descripcin ya existe';   
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN descriptionNoExist THEN
  resultpr := 'ERROR: La descripcin no existe';   
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN  noAction THEN
  resultpr := 'ERROR: accin a realizar no vlida';   
  pr_insert_logs (nameprocedure, paramin, resultpr); 
WHEN  noAppInsert THEN
  resultpr := 'ERROR: La aplicacin a la que hacer ref. no existe';   
  pr_insert_logs (nameprocedure, paramin, resultpr);  
WHEN noMinDes THEN
  resultpr := 'ERROR: no se puede borrar la nica descripcin';   
  pr_insert_logs (nameprocedure, paramin, resultpr);  
WHEN OTHERS THEN
  err_num:= SQLCODE;
  err_msg := substr(SQLERRM, 1, 200);
  resultpr := 'ERROR: '|| TO_CHAR (err_num) || err_msg;
  pr_insert_logs (nameprocedure, paramin, resultpr);



end pr_abm_descriptions;

/
--------------------------------------------------
-- ALTA, BAJA O MODIFICACIN DE PRECIOS
-- DATOS DE ENTRADA
--	ACTION ('A','B' o 'M')
--	APPIDENTIF
--  NAMEOS
--  VERSIONAPP
--  CODECOUNTRY
--  PPRICE
--DATOS DE SALIDA
--  RESULTPR (RSP)
--------------------------------------------------
create or replace
procedure pr_abm_prices
(
    Paction in char,
    PappIdentif in price.appidentif%type,
    PnameOs in price.nameos%type,
    PversionApp in price.versionapp%type,
    PcodeCountry in price.codecountry%type,
    Pprice in price.price%type,
    resultpr out nocopy varchar2
)as 
-- DECLARACIN DE VARIABLES
  
  noAction EXCEPTION;  
  noAppIdentif EXCEPTION;
  noNameOs EXCEPTION;
  noVersionApp EXCEPTION;
  noCodeCountry EXCEPTION;
  noPrice EXCEPTION;
  priceExist EXCEPTION;
  priceNoExist EXCEPTION;
  noAppInsert EXCEPTION;
  noMinPrice EXCEPTION;
  err_num        NUMBER;
  err_msg        VARCHAR2(3500);
  
    aux number;
    aux2 number;
    paramin logs.paramin%type;
    nameprocedure logs.nameprocedure%type;
  
begin
--INICIALIZACIN DE VARIABLES
  resultpr := 'Ok';
  paramin := '<'|| Paction ||'><'|| PappIdentif ||'><'|| PnameOs ||'><'||PversionApp ||'><'|| PcodeCountry
                ||'><'||Pprice||'>';
  nameprocedure := 'pr_abm_prices';
        
   -- COMPROBACIN DE PARMETROS DE ENTRADA
  IF (Paction IS NULL OR Paction ='') THEN
    RAISE noAction;
  END IF;
  IF (PappIdentif IS NULL OR PappIdentif = '') THEN
    RAISE noAppIdentif;
  END IF;
  IF (PversionApp IS NULL OR PversionApp = '') THEN
    RAISE noVersionApp;
  END IF;
  IF (PnameOS IS NULL OR PnameOS = '') THEN
    RAISE noNameOS;
  END IF;
  IF (PcodeCountry IS NULL OR PcodeCountry = '') THEN
    RAISE noCodeCountry;
  END IF;
    
  --- en el caso de un alta o modificacin tiene que existir un precio (para baja no es necesario)
  IF (Paction = 'A' OR Paction ='M') THEN
    IF (Pprice IS NULL OR Pprice = '') THEN
      RAISE noPrice;
    END IF;
  END IF;
  
  SELECT COUNT(*) INTO aux FROM price WHERE appIdentif = PappIdentif AND versionApp = pversionapp AND nameOs = pnameOs AND codecountry=pcodecountry;
  -- Alta price
  IF (Paction = 'A' OR Paction = 'a') THEN
    --- Si el precio no est dado de alta y existe la aplicacin se inserta, si ya est dado de alta
    --- devuelve mensaje de error.
    --- Si no existe aplicacion dada de alta notifica error 
    
    IF (aux=0)  THEN
      SELECT COUNT(*) INTO aux2 FROM applications WHERE appidentif=PappIdentif AND nameOS = PnameOs AND versionapp= pversionapp;
      IF (aux2 >0) THEN
        INSERT INTO price (appidentif,versionApp, nameOs, codecountry, price)
                  VALUES (PappIdentif, pversionApp, PnameOS, pcodeCountry, pprice);
      ELSE
        RAISE noAppInsert;
      END IF;
    ELSE 
      RAISE priceExist;
    END IF;
    -- Inserccin correcta del precio
    pr_insert_logs (nameprocedure, paramin, resultpr); 
ELSE IF (Paction = 'B' OR Paction = 'b') THEN
        --Baja de un precio. Si el precio est dado de alta se borra,
        --sino se notifica error.
        IF (aux =1) THEN
          -- Comprobamos que no sea el nico registro ya que si se borra, incumplira la
          -- restriccin de tener como mnimo un precio asignado
          SELECT COUNT(*) INTO aux2 FROM price WHERE appIdentif = PappIdentif AND versionApp = pversionapp AND nameOs = pnameOs;
          IF (aux2 > 1) THEN
            DELETE FROM price WHERE appIdentif = PappIdentif AND versionApp = pversionapp AND nameOs = pnameOs AND codeCountry=pcodeCountry;
          ELSE
            RAISE noMinPrice;
          END IF;
        ELSE 
                RAISE priceNoExist;
        END IF;
            -- Borrado correcto del precio
            pr_insert_logs (nameprocedure, paramin, resultpr);
     ELSE IF (Paction = 'M' OR Paction = 'm') THEN
          --Modificacin del precio. Si existe se modifica, 
          --sino se notifica error
            IF (aux =1) THEN
              UPDATE price SET price = pprice
                WHERE appIdentif = PappIdentif AND versionApp = pversionapp AND nameOs = pnameOs AND codeCountry = pcodeCountry;
                -- Modificacin correcta del precio
                 pr_insert_logs (nameprocedure, paramin, resultpr);
            ELSE 
              RAISE priceNoExist;
            END IF;
          ELSE 
             RAISE noAction;
          END IF;
   END IF;  
END IF;
  -- CONTROL DE EXCEPCIONES
EXCEPTION
WHEN noAppIdentif THEN
  resultpr := 'ERROR: debe introducir una aplicacin';
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noNameOs THEN
  resultpr := 'ERROR: debe introducir un sistema operativo';   
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN  noVersionApp THEN
  resultpr := 'ERROR: debe introducir la versin';   
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noCodeCountry THEN
  resultpr := 'ERROR: debe introducir el cdigo del pas';
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noPrice THEN
  resultpr := 'ERROR: debe introducir el precio';   
  pr_insert_logs (nameprocedure, paramin, resultpr);  
WHEN priceExist THEN
  resultpr := 'ERROR: El precio ya existe';   
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN priceNoExist THEN
  resultpr := 'ERROR: El precio no existe';   
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN  noAction THEN
  resultpr := 'ERROR: accin a realizar no vlida';   
  pr_insert_logs (nameprocedure, paramin, resultpr); 
WHEN  noAppInsert THEN
  resultpr := 'ERROR: La aplicacin a la que hacer ref. no existe';   
  pr_insert_logs (nameprocedure, paramin, resultpr);  
WHEN  noMinPrice THEN
  resultpr := 'ERROR: no se puede borrar, debe existir 1 precio mnimo';   
  pr_insert_logs (nameprocedure, paramin, resultpr);  
WHEN OTHERS THEN
  err_num:= SQLCODE;
  err_msg := substr(SQLERRM, 1, 200);
  resultpr := 'ERROR: '|| TO_CHAR (err_num) || err_msg;
  pr_insert_logs (nameprocedure, paramin, resultpr);


end pr_abm_prices;
/
--------------------------------------------------
-- ALTA, BAJA O MODIFICACIN DE URL
-- DATOS DE ENTRADA
--	ACTION ('A','B' o 'M')
--	APPIDENTIF
--  NAMEOS
--  APPLANGUAGESURL
--  APPURLVIDEO
--DATOS DE SALIDA
--  RESULTPR (RSP)
--------------------------------------------------

create or replace
procedure pr_abm_urls
(
    Paction in char,
    PappIdentif in appurlvideo.appIdentif%type,
    PnameOs in appurlvideo.nameOs%type,
    PappLanguageUrl in appurlvideo.languageUrl%type,
    PurlVideo in appurlvideo.urlVideo%type,
    resultpr out nocopy varchar2
)as 
-- DECLARACIN DE VARIABLES
  
  noAction EXCEPTION;  
  noAppIdentif EXCEPTION;
  noAppLanguagesUrl EXCEPTION;
  noNameOS EXCEPTION;
  noAppUrl EXCEPTION;
  urlExist EXCEPTION;
  urlNoExist EXCEPTION;
  noAppInsert EXCEPTION;
  err_num        NUMBER;
  err_msg        VARCHAR2(3500);
  
    aux number;
    aux2 number;
    paramin logs.paramin%type;
    nameprocedure logs.nameprocedure%type;
  
begin
--INICIALIZACIN DE VARIABLES
  resultpr := 'Ok';
  paramin := '<'|| Paction ||'><'|| PappIdentif ||'><'|| PnameOs ||'><'||PappLanguageUrl ||'><'|| PurlVideo ||'>';
  nameprocedure := 'pr_abm_urls';
             
   -- COMPROBACIN DE PARMETROS DE ENTRADA
  IF (Paction IS NULL OR Paction ='') THEN
    RAISE noAction;
  END IF;
  IF (PappIdentif IS NULL OR PappIdentif = '') THEN
    RAISE noAppIdentif;
  END IF;
   IF (PnameOS IS NULL OR PnameOS = '') THEN
    RAISE noNameOS;
  END IF;
  IF (PappLanguageUrl IS NULL OR PappLanguageUrl = '') THEN
    RAISE noAppLanguagesUrl;
  END IF;
  
  --- en el caso de un alta o modificacin tiene que existir la url (para baja no es necesario)
  IF (Paction = 'A' OR Paction ='M') THEN
    IF (PurlVideo IS NULL OR PurlVideo = '') THEN
      RAISE noAppUrl;
    END IF;
  END IF;
  
  SELECT COUNT(*) INTO aux FROM appUrlVideo WHERE appIdentif = PappIdentif AND languageurl = papplanguageurl AND nameOs = pnameOs;
  -- Alta url
  IF (Paction = 'A' OR Paction = 'a') THEN
    --- Si la url no est dado de alta y existe la aplicacin se inserta, si ya est dado de alta
    --- devuelve mensaje de error.
    --- Si no existe aplicacion dada de alta notifica error 
    
    IF (aux=0)  THEN
      SELECT COUNT(*) INTO aux2 FROM app_os WHERE appidentif=PappIdentif AND nameOS = PnameOs;
      IF (aux2 >0) THEN
        INSERT INTO appurlVideo (appidentif, nameOs, languageurl, urlVideo)
                  VALUES (PappIdentif, PnameOS, papplanguageUrl, pUrlVideo);
      ELSE
        RAISE noAppInsert;
      END IF;
    ELSE 
      RAISE urlExist;
    END IF;
    -- Inserccin correcta de la url
    pr_insert_logs (nameprocedure, paramin, resultpr); 
ELSE IF (Paction = 'B' OR Paction = 'b') THEN
        --Baja de la url. Si la url est dado de alta se borra,
        --sino se notifica error.
        IF (aux =1) THEN
         DELETE FROM appUrlVideo WHERE appIdentif = PappIdentif AND nameOs = pnameOs AND languageurl = papplanguageurl;
        ELSE 
                RAISE urlNoExist;
        END IF;
            -- Borrado correcto de la descripcin
            pr_insert_logs (nameprocedure, paramin, resultpr);
     ELSE IF (Paction = 'M' OR Paction = 'm') THEN
          --Modificacin de la url. Si existe se modifica, 
          --sino se notifica error
            IF (aux =1) THEN
              UPDATE appurlVideo SET urlVideo = pUrlVideo
                WHERE appIdentif = PappIdentif AND languageurl = papplanguageurl AND nameOs = pnameOs;
                -- Modificacin correcta de la descripcin
                 pr_insert_logs (nameprocedure, paramin, resultpr);
            ELSE 
              RAISE urlNoExist;
            END IF;
          ELSE 
             RAISE noAction;
          END IF;
   END IF;  
END IF;
  -- CONTROL DE EXCEPCIONES
EXCEPTION
WHEN noAppIdentif THEN
  resultpr := 'ERROR: debe introducir una aplicacin';
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noAppLanguagesUrl THEN
  resultpr := 'ERROR: debe introducir el idioma del vdeo';   
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noNameOS THEN
  resultpr := 'ERROR: debe introducir sistema operativo';   
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noAppUrl THEN
  resultpr := 'ERROR: debe introducir la url del vdeo';   
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN urlExist THEN
  resultpr := 'ERROR: La url ya existe';   
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN urlNoExist THEN
  resultpr := 'ERROR: La url no existe';   
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN  noAction THEN
  resultpr := 'ERROR: accin a realizar no vlida';   
  pr_insert_logs (nameprocedure, paramin, resultpr); 
WHEN  noAppInsert THEN
  resultpr := 'ERROR: La aplicacin a la que hacer ref. no existe';   
  pr_insert_logs (nameprocedure, paramin, resultpr);  
WHEN OTHERS THEN
  err_num:= SQLCODE;
  err_msg := substr(SQLERRM, 1, 200);
  resultpr := 'ERROR: '|| TO_CHAR (err_num) || err_msg;
  pr_insert_logs (nameprocedure, paramin, resultpr);

end pr_abm_urls;
/

--------------------------------------------------------------------------------------
-- MODIFICACIN DE UNA APLICACIN
-- DATOS DE ENTRADA
--  appIdentif (nombre identificativo de la aplicacin)
--  versionApp (versin de la aplicacin)
--  nameOs (sistema operativo de la aplicacin)
--  minResoScreen (resolucin mn. de pantalla que necesita de la aplicacin)
--  sizeApp (tamao de la aplicacin)
--  linkApp (link para descargar la aplicacin)
--  active (si est activa la aplicacin)
-- DATOS DE SALIDA
--  resultpr (resultado del procedimiento (RSP))
---------------------------------------------------------------------------------------
create or replace
procedure pr_update_app
(
  PappIdentif in applications.appIdentif%type,
  PversionApp in applications.versionapp%type,
  PnameOs in applications.nameOS%type,
  PminResoScreen in applications.minresoscreen%type,
  PsizeApp in applications.sizeapp%type,
  PlinkApp in applications.linkapp%type,
  Pactive in applications.active%type,
  resultpr out nocopy varchar2
)as 

--DECLARACIN DE VARIABLES
  nameprocedure logs.nameprocedure%type;
  paramin logs.paramin%type;
  RSP		VARCHAR2(100);
  aux number;
  aux2 varchar2(1);
  cappIdentif applications.appidentif%type;
  cnameOs applications.nameOs%type;
  cversionApp applications.versionApp%type;
  cdateUp applications.dateUp%type;
   
  noAppIdentif EXCEPTION;
  noVersion EXCEPTION;
  noNameOS EXCEPTION;
  noMinResoScreen EXCEPTION;
  noSizeApp EXCEPTION;
  noLink EXCEPTION;
  noActive EXCEPTION;
  appNoExist EXCEPTION;
  versionPostApp EXCEPTION;
  err_num        NUMBER;
  err_msg        VARCHAR2(3500);
  
  BEGIN
-- INICIALIZACIN DE VARIABLES
  resultpr := 'Ok';
  paramin := '<'|| PappIdentif||'><'||PversionApp ||'><'|| PnameOs||'><'||PminResoScreen||'><'||
              PsizeApp||'><'||PlinkApp||'><'||Pactive||'>';
  nameprocedure := 'pr_update_app';
  
  -- COMPROBACIN DE PARMETROS DE ENTRADA
  IF (PappIdentif IS NULL OR PappIdentif = '') THEN
    RAISE noAppIdentif;
  END IF; 
  IF (PversionApp IS NULL OR PversionApp = '') THEN
    RAISE noVersion;
  END IF;
  IF (PnameOs IS NULL OR PnameOs = '') THEN
    RAISE noNameOs;
  END IF; 
  ----Comprobamos que est dada de alta 
  SELECT COUNT(*) INTO aux FROM applications WHERE (appIdentif = PappIdentif AND versionApp = PversionApp AND nameOS = PnameOs AND dateDelete is null);
  IF (aux = 0)  THEN
       RAISE appNoExist;
  END IF;
  IF (PminResoScreen IS NULL OR PminResoScreen = '') THEN
    RAISE noMinResoScreen;
  END IF;
  IF (PsizeApp IS NULL OR PsizeApp = '') THEN
    RAISE noSizeApp;
  END IF;
  IF (PlinkApp IS NULL OR PlinkApp = '') THEN
    RAISE nolink;
  END IF;
  IF (Pactive IS NULL OR Pactive = '') THEN
    RAISE noActive;
  END IF;
  
 -- MODIFICACIN DEL REGISTRO
 
  -- Pactive='N' y la aplicacin est activa, hay que activar la versin anterior (no dada de baja)
   SELECT active, dateUp INTO aux2, cdateUp FROM applications 
      WHERE(appIdentif = PappIdentif AND versionApp = PversionApp AND nameOS=PnameOS);
     
  IF (Pactive='N' AND aux2='S') THEN
   SELECT appIdentif, nameOs, versionApp INTO cappIdentif, cnameOs, cversionApp FROM 
        (SELECT appIdentif, nameOs, versionApp FROM applications 
          WHERE (appIdentif = PappIdentif AND nameOS=PnameOs AND active='N' AND dateDelete is null AND dateUp < cdateUp)
          ORDER BY dateup DESC ) WHERE ROWNUM = 1;
   UPDATE applications SET  active='S' WHERE (appIdentif = cappIdentif AND nameOs=cnameOs AND versionApp=cversionApp);        
  END IF;
  
  -- Si Pactive='S' y existe una aplicacin posterior active emitir error
  IF (Pactive='S' AND aux2='N') THEN
    SELECT COUNT(*) INTO aux FROM applications WHERE (appIdentif = PappIdentif AND nameOs = PnameOs AND active='S' 
                  AND dateUp > cdateUp);
    IF (aux > 0) THEN
      RAISE versionPostApp;
    ELSE
      UPDATE applications SET active ='N' WHERE (appIdentif = PappIdentif AND nameOS=PnameOS);
    END IF;
  END IF;
  
  UPDATE applications SET minResoScreen = PminResoScreen,
                          sizeApp = PsizeApp,
                          linkApp = PlinkApp,
                          active = Pactive
        WHERE (appIdentif = PappIdentif AND nameOs = PnameOs AND versionApp = PversionApp);
        
  -- Modificaciones realizadas correctamente
  pr_insert_logs (nameprocedure, paramin, resultpr);
  
      -- CONTROL DE EXCEPCIONES
EXCEPTION
WHEN noAppIdentif THEN
  resultpr := 'ERROR: debe introducir el nombre de la aplicacin';
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noVersion THEN
  resultpr := 'ERROR: debe introducir la versin de la aplicacin';
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noNameOS THEN
  resultpr := 'ERROR: debe introducir el sistema operativo de la aplicacin';
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noMinResoScreen THEN
  resultpr := 'ERROR: debe introducir la resolucin mn. para la aplicacin'; 
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noSizeApp THEN
  resultpr := 'ERROR: debe introducir el tamao de la aplicacin'; 
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noLink THEN
  resultpr := 'ERROR: debe introducir el link de la aplicacin'; 
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN versionPostApp THEN
  resultpr := 'ERROR: existe una versin posterior activa'; 
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noActive THEN
  resultpr := 'ERROR: debe introducir si est activa o no'; 
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN appNoExist THEN
  resultpr := 'ERROR: la aplicacin no existe';    
  pr_insert_logs (nameprocedure, paramin, resultpr);

WHEN OTHERS THEN
  err_num:= SQLCODE;
  err_msg := substr(SQLERRM, 1, 200);
  resultpr := 'ERROR: '|| TO_CHAR (err_num) || err_msg;
  pr_insert_logs (nameprocedure, paramin, resultpr);

end pr_update_app;
/
---------------------------------------------------------------------------------------------------
-- PROCEDIMIENTO PARA DAR DE ALTA UNA APLICACIN
-- SE DAR DE ALTA LA APLICACIN CON LOS DATOS MNIMOS
-- (SOLO UNA DESCRIPCIN, UN PRECIO Y UNA URL DE VIDEO COMO
-- MXIMO, PARA AADIR MS SE HAR CON OTROS PROCEDIMIENTOS)
-- DATOS DE ENTRADA
--  APPIDENTIF (Identificador o nombre de la aplicacin)
--  VERSIONAPP  (Versin de la aplicacin)
--  NAMEOS (Nombre del sistema operativo para el que es la aplicacin)
--  MINRESOSCREEN (La resolucin mnima que necesita la aplicacin)
--  SIZEAPP (Tamao de la aplicacin)
--  LINK (link de la aplicacin)
--  DESCRIPTION (Descripcin de la aplicacin)
--  LANGUAGESDES (Idioma de la descripcin de la aplicacin)
--  CODECOUNTRY (Cdigo del pas donde se va a vender de la aplicacin, para el precio)
--  PRICE (Precio de la aplicacin (en el pas CODECOUNTRY))
--  URLVIDEO (Url de un video demostrativo de la aplicacin **OPCIONAL)
--  LANGUAGEURL (Idioma del vdeo **SOLO SI SE INTRODUCE URLVIDEO)
--  DEVELOPERS (Programadores de la aplicacin ** SI HAY MS DE UNO DEBEN IR SEPARADOS POR ',')
------------------------------------------------------------------------------------------------
create or replace
procedure pr_insert_app 
(
  PappIdentif in applications.appIdentif%type,
  PversionApp in applications.versionapp%type,
  PnameOs in applications.nameOS%type,
  PminResoScreen in applications.minResoScreen%type,
  PsizeApp in applications.sizeApp%type,
  Plink in applications.linkApp%type,
  Pdescription in appDescription.description%type,
  PlanguagesDes in appDescription.languageDes%type,
  PcodeCountry in price.codeCountry%type,
  Pprice in price.price%type,
  Purlvideo in appUrlVideo.urlVideo%type,
  PlanguageUrl in appurlvideo.languageurl%type,
  Pdevelopers in varchar2,
  resultpr out nocopy varchar2
)as 

--DECLARACIN DE VARIABLES
  nameprocedure logs.nameprocedure%type;
  paramin logs.paramin%type;
  cDateUp applications.dateup%type;
  RSP		VARCHAR2(100);
  aux number(1);
  aux2 number;
  exist number;
  pos number(1);
  letra varchar2(1);
  cdeveloper varchar2(20);
  baja applications.dateDelete%type;
  
   
  noAppIdentif EXCEPTION;
  noVersion EXCEPTION;
  noNameOS EXCEPTION;
  noMinResoScreen EXCEPTION;
  noSizeApp EXCEPTION;
  noLink EXCEPTION;
  noDescription EXCEPTION;
  noLanguagesDes EXCEPTION;
  noCodeCountry EXCEPTION;
  noPrice EXCEPTION;
  appExist EXCEPTION;
  noDevelopers EXCEPTION;
  noLanguageUrl EXCEPTION;
  err_num        NUMBER;
  err_msg        VARCHAR2(3500);

begin
-- INICIALIZACIN DE VARIABLES
  resultpr := 'Ok';
  cDateUp := SYSDATE;
  paramin := '<'|| PappIdentif||'><'||PversionApp ||'><'|| PnameOs||'><'|| PminResoScreen ||'><'||
             PsizeApp||'><'|| Plink ||'><'||Pdescription||'><'||PlanguagesDes||'><'|| 
             PcodeCountry ||'><'||Pprice ||Purlvideo||'><'||PlanguageUrl||'><'||Pdevelopers||'>';

  nameprocedure := 'pr_insert_app';

  
  -- COMPROBACIN DE PARMETROS DE ENTRADA
  IF (PappIdentif IS NULL OR PappIdentif = '') THEN
    RAISE noAppIdentif;
  END IF; 
  IF (PversionApp IS NULL OR PversionApp = '') THEN
    RAISE noVersion;
  END IF;
  IF (PnameOs IS NULL OR PnameOs = '') THEN
    RAISE noNameOs;
  END IF; 
 
   ----Comprobamos que no est ya dado de alta ( y sin fecha de baja)  
  SELECT COUNT(*) INTO aux FROM applications WHERE (appIdentif = PappIdentif AND versionApp = PversionApp AND nameOS = PnameOs);
  
  IF (aux = 1)  THEN
    SELECT datedelete INTO baja FROM applications WHERE appIdentif = PappIdentif AND versionApp = PversionApp AND nameOS = PnameOs;
     IF (baja is null) THEN
      RAISE appExist;
    END IF;
  END IF;
 
  IF (PMinResoScreen IS NULL OR PMinResoScreen = '') THEN
    RAISE noMinResoScreen;
  END IF;
  IF (PsizeApp IS NULL OR PsizeApp = '') THEN
    RAISE noSizeApp;
  END IF;
  IF (Plink IS NULL OR Plink = '') THEN
    RAISE noLink;
  END IF;
  IF (PcodeCountry IS NULL OR PcodeCountry = '') THEN
    RAISE noCodeCountry;
  END IF;
  
  -- Comprobamos que haya una descripcin en el caso de que no exista ninguna para esta aplicacin
  -- se debe haber una descripccin en los datos de entrada
  SELECT COUNT(*) INTO aux2 FROM appdescription WHERE appIdentif = PappIdentif;
  IF (aux2=0) THEN
    IF (Pdescription IS NULL OR Pdescription = '') THEN
      RAISE noDescription;
    END IF;
    IF (PlanguagesDes IS NULL OR PlanguagesDes = '') THEN
      RAISE noLanguagesDes;
    END IF; 
  END IF;
  
  IF (Pprice IS NULL OR Pprice = '') THEN
    RAISE noPrice;
  END IF;  
  IF (PurlVideo IS NOT NULL OR PurlVideo='') THEN
    IF (PlanguageUrl IS NULL OR PlanguageUrl='') THEN
      RAISE noLanguageUrl;
    END IF;
  END IF;
 IF (Pdevelopers IS NULL OR Pdevelopers = '') THEN
    RAISE noDevelopers;
  END IF; 
  
-- Dar de alta una aplicacin
    -- Si est dado de baja (existe la aplicacin pero con fecha de baja) ser reactivar con los datos introducidos y fecha de alta actual
    -- Si no est dado de alta se har la insercin a la tabla (por defecto se pone como versin activa y se desactiva el resto)
    
 UPDATE applications SET active ='N' WHERE (appIdentif = PappIdentif AND nameOS=PnameOS);
 IF (baja is not null AND aux = 1) THEN
      RSP:= 'OK';
      update applications set datedelete = '' where (appIdentif = PappIdentif AND versionApp = PversionApp AND nameOS = PnameOs);
      pr_update_app(PappIdentif, PversionApp, PnameOs, PminResoScreen, PsizeApp, Plink, 'S',RSP);
      update applications set dateup = cDateUp where (appIdentif = PappIdentif AND versionApp = PversionApp AND nameOS = PnameOs);
      delete from appdevelope where appIdentif=PappIdentif AND versionApp = PversionApp AND nameOs = PnameOs;
      delete from price where appIdentif=PappIdentif AND versionApp = PversionApp AND nameOs = PnameOs;
      delete from appurlvideo where appIdentif=PappIdentif AND nameOs = PnameOs;
      
      resultpr :='Aplicacin Reactivada';
  ELSE   
  -- insertamos el registro en applications
  SELECT COUNT(*) INTO exist FROM app WHERE appidentif = pappidentif;
  IF (exist =0) THEN
    INSERT INTO app (appidentif) VALUES (pAppIdentif);
    INSERT INTO app_os (appIdentif, nameOs) VALUES (pAppIdentif, pNameOs);
  ELSE
    SELECT COUNT(*) INTO exist FROM app_os WHERE appIdentif = pAppIdentif AND nameOs = pNameOs;
    IF (exist = 0) THEN
      INSERT INTO app_os (appIdentif, nameOs) VALUES (pAppIdentif, pNameOs);
    END IF;
  END IF;
    INSERT INTO applications
      ( appidentif, versionapp, nameos, dateup, minresoscreen, sizeapp, linkapp, active)
        values
        (PappIdentif, pversionapp, PnameOS, cdateup, pminresoscreen, psizeapp, plink, 'S' );
  END IF;
 -- Insertamos la descripcin de la aplicacin, si ya existe la modificamos
    IF (aux2 >0) THEN
      SELECT COUNT(*) INTO aux2 FROM appDescription WHERE appIdentif=PappIdentif AND languageDes=PlanguagesDes;
      IF (aux2>0) THEN
        pr_abm_descriptions ('M',PappIdentif, PLanguagesDes, pDescription, RSP);
      ELSE
        pr_abm_descriptions ('A',PappIdentif, PLanguagesDes, pDescription, RSP);
      END IF;
    ELSE
        pr_abm_descriptions ('A',PappIdentif, PLanguagesDes, pDescription, RSP);
    END IF;
     
  -- Insertamos el precio de la aplicacin
   INSERT INTO price
      (appIdentif, versionApp, nameOs, codeCountry, price)
      VALUES
      (PappIdentif, PversionApp, PnameOs, PcodeCountry, Pprice);
      
  -- Insertamos los progradores
  FOR pos IN 1..LENGTH(Pdevelopers) LOOP
     letra:= substr(Pdevelopers,pos,1); 
      IF (letra = ',') THEN
          INSERT INTO appdevelope
            (appIdentif, versionApp, nameOS, developerId)
          VALUES
            (PappIdentif, PversionApp, PnameOs, cdeveloper);
          cdeveloper :=null;
      else
          cdeveloper:= cdeveloper || letra;
      END IF;
  END LOOP;
  INSERT INTO appdevelope
            (appIdentif, versionApp, nameOS, developerId)
          VALUES
            (PappIdentif, PversionApp, PnameOs, cdeveloper);
  -- en caso de que se haya introducido una url se da de alta si no exista o se modificar
  -- la con la nueva
  SELECT COUNT(*) INTO aux2 FROM appurlVideo WHERE appIdentif=PappIdentif AND nameOs=PnameOs AND languageUrl=PlanguageUrl;
  IF (aux2 > 0) THEN
    pr_abm_urls ('M', pAppIdentif, pNameOs,pLanguageUrl, pUrlVideo,RSP);
  ELSE
    pr_abm_urls ('A',pAppIdentif, pNameOs,pLanguageUrl, pUrlVideo,RSP);
  END IF;
  
  -- se ha insertado/reactivado correctamente
  pr_insert_logs (nameprocedure, paramin, resultpr);
  
  
    -- CONTROL DE EXCEPCIONES
EXCEPTION
WHEN noAppIdentif THEN
  resultpr := 'ERROR: debe introducir el nombre de la aplicacin';
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noVersion THEN
  resultpr := 'ERROR: debe introducir la versin de la aplicacin';
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noNameOS THEN
  resultpr := 'ERROR: debe introducir el sistema operativo de la aplicacin';
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noMinResoScreen THEN
  resultpr := 'ERROR: debe introducir la resolucin mn. para la aplicacin'; 
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noSizeApp THEN
  resultpr := 'ERROR: debe introducir el tamao de la aplicacin'; 
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noLink THEN
  resultpr := 'ERROR: debe introducir el link de la aplicacin'; 
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noDescription THEN
  resultpr := 'ERROR: debe introducir la descripcin de la aplicacin'; 
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noLanguagesDes THEN
  resultpr := 'ERROR: debe introducir el idioma de la aplicacin';    
  pr_insert_logs (nameprocedure, paramin, resultpr);  
WHEN noCodeCountry THEN
  resultpr := 'ERROR: debe introducir el pas de venta de la aplicacin';    
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noPrice THEN
  resultpr := 'ERROR: debe introducir el precio de la aplicacin';    
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN appExist THEN
  resultpr := 'ERROR: ya existe la misma versin de la aplicacin en el mismo S.O.';    
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noDevelopers THEN
  resultpr := 'ERROR: se debe introducir el/los programadores';    
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noLanguageUrl THEN
  resultpr := 'ERROR: se debe introducir el lenguaje del vdeo';    
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN OTHERS THEN
  err_num:= SQLCODE;
  err_msg := substr(SQLERRM, 1, 200);
  resultpr := 'ERROR: '|| TO_CHAR (err_num) || err_msg;
  pr_insert_logs (nameprocedure, paramin, resultpr);
 
  
end pr_insert_app;
/

--------------------------------------------------------------------------------------
-- PROCEDIMIENTO BAJA (FECHA BAJA) DE UNA APLICACIN
-- DATOS DE ENTRADA
--  appIdentif (nombre identificativo de la aplicacin)
--  versionApp (versin de la aplicacin)
--  nameOs (sistema operativo de la aplicacin)
-- DATOS DE SALIDA
--  resultpr (resultado del procedimiento (RSP))
---------------------------------------------------------------------------------------

create or replace
procedure pr_delete_app
(
  PappIdentif in applications.appIdentif%type,
  PversionApp in applications.versionapp%type,
  PnameOs in applications.nameOS%type,
  resultpr out nocopy varchar2
)as 

--DECLARACIN DE VARIABLES
  nameprocedure logs.nameprocedure%type;
  paramin logs.paramin%type;
  RSP		VARCHAR2(100);
  aux number;
  aux2 varchar2(1);
  cappIdentif applications.appidentif%type;
  cnameOs applications.nameOs%type;
  cversionApp applications.versionApp%type;
  cdateUp applications.dateUp%type;
  baja applications.datedelete%type;
  
  noAppIdentif EXCEPTION;
  noVersion EXCEPTION;
  noNameOS EXCEPTION;
  appNoExist EXCEPTION;
  err_num        NUMBER;
  err_msg        VARCHAR2(3500);
  
  BEGIN
-- INICIALIZACIN DE VARIABLES
  resultpr := 'Ok';
  paramin := '<'|| PappIdentif||'><'||PversionApp ||'><'|| PnameOs||'>';
  nameprocedure := 'pr_delete_app';
  baja:= SYSDATE;

  
  -- COMPROBACIN DE PARMETROS DE ENTRADA
  IF (PappIdentif IS NULL OR PappIdentif = '') THEN
    RAISE noAppIdentif;
  END IF; 
  IF (PversionApp IS NULL OR PversionApp = '') THEN
    RAISE noVersion;
  END IF;
  IF (PnameOs IS NULL OR PnameOs = '') THEN
    RAISE noNameOs;
  END IF; 
  ----Comprobamos que est dada de alta 
  SELECT COUNT(*) INTO aux FROM applications WHERE (appIdentif = PappIdentif AND versionApp = PversionApp AND nameOS = PnameOs AND dateDelete is null);
  IF (aux = 0)  THEN
       RAISE appNoExist;
  END IF;
  
  -- Si existe y est activa habr que activar la versin anterior (en caso de que haya una versin anterior)
  IF (aux > 1) THEN
  SELECT active, dateUp INTO aux2, cdateUp FROM applications 
      WHERE(appIdentif = PappIdentif AND versionApp = PversionApp AND nameOS=PnameOS);
      
  IF (aux2='S') THEN
    SELECT appIdentif, nameOs, versionApp INTO cappIdentif, cnameOs, cversionApp FROM 
        (SELECT * FROM applications 
          WHERE (appIdentif = PappIdentif AND nameOS=PnameOs AND active='N' AND dateDelete is null AND dateUp < cdateUp)
          ORDER BY dateup DESC ) WHERE ROWNUM = 1;
    UPDATE applications SET  active='S' WHERE (appIdentif = cappIdentif AND nameOs=cnameOs AND versionApp=cversionApp);        
  END IF;
  END IF;
  
  -- Introducimos la fecha de baja
  UPDATE applications SET dateDelete = baja, active='N' WHERE (appIdentif = PappIdentif AND nameOS=PnameOs AND versionApp = PversionApp);
  
   -- Baja realizada correctamente
  pr_insert_logs (nameprocedure, paramin, resultpr);
  
        -- CONTROL DE EXCEPCIONES
EXCEPTION
WHEN noAppIdentif THEN
  resultpr := 'ERROR: debe introducir el nombre de la aplicacin';
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noVersion THEN
  resultpr := 'ERROR: debe introducir la versin de la aplicacin';
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noNameOS THEN
  resultpr := 'ERROR: debe introducir el sistema operativo de la aplicacin';
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN appNoExist THEN
  resultpr := 'ERROR: la aplicacin no existe';    
  pr_insert_logs (nameprocedure, paramin, resultpr);

WHEN OTHERS THEN
  err_num:= SQLCODE;
  err_msg := substr(SQLERRM, 1, 200);
  resultpr := 'ERROR: '|| TO_CHAR (err_num) || err_msg;
  pr_insert_logs (nameprocedure, paramin, resultpr);

end pr_delete_app;

/

-------------------------------------------------------------------------------------
-- PROCEDIMIENTO PARA MODIFICAR UN PROGRAMADOR
--  DATOS DE ENTRADA:
--     DEVELOPERID
--     NAMECOMP
--    NAMELEGALREPRES
--    SURNAMELEGALREPRES
--    IDCARDREPRES
--    COUNTRYCODE
--    HEADOFFICEADDRESS
--    HEADOFFICECITY
--    HEADOFFICECP
--    TELEPHONE1
--    TELEPHONE2
--    EMAIL
--  DATOS DE SALIDA:
--    RESULTPR (RSP)
--------------------------------------------------------------------------------------
create or replace
procedure pr_update_developer
(
  Pdeveloperid in developers.developerid%type,
  PnameComp in developers.namecomp%type,
  PnameLegalRepres in developers.namelegalrepres%type,
  PsurnameLegalRepres in developers.surnamelegalrepres%type,
  PidCardRepres in developers.idcardrepres%type,
  PcountryCode in developers.countrycode%type,
  PheadOfficeAddress in developers.headofficeaddress%type,
  PheadOfficeCity in developers.headofficecity%type,
  PheadOfficeCp in developers.headofficecp%type,
  PheadOfficeProvince in developers.headofficeprovince%type,
  Ptelephone1 in developers.telephone1%type,
  Ptelephone2 in developers.telephone2%type,
  Pemail in developers.email%type,
  resultpr out nocopy varchar2
)as 
-- DECLARACIN DE VARIABLES
  nameprocedure logs.nameprocedure%type;
  paramin logs.paramin%type;
  RSP		VARCHAR2(100);
  aux number(1);
  aux2 number(1);
  baja developers.datedelete%type;
    
  noDeveloperId EXCEPTION;
  idNoExist EXCEPTION;
  idBaja EXCEPTION;
  nameComExist EXCEPTION;
  noNameCom EXCEPTION;
  noNameLegalR EXCEPTION;
  noSurnameLegalR EXCEPTION;
  noIdCardR EXCEPTION;
  noCodeCountry EXCEPTION;
  noHOAddress EXCEPTION;
  noHOCity EXCEPTION;
  noHOCp EXCEPTION;
  noHOProvince EXCEPTION;
  noTelephone1 EXCEPTION;
  noHOEmail EXCEPTION;
  err_num        NUMBER;
  err_msg        VARCHAR2(3500);
  
begin

-- INICIALIZACIN DE VARIABLES
  resultpr := 'Ok';
  paramin := '<'|| Pdeveloperid ||'><'|| PnameComp ||'><'|| PnameLegalRepres ||'><'|| PsurnameLegalRepres ||'><'||
             PidCardRepres ||'><'|| PcountryCode ||'><'|| PheadOfficeAddress ||'><'||PheadOfficeCity ||'><'||
             PheadOfficeCp ||'><'|| PheadOfficeProvince ||'><'|| Ptelephone1||'><'||Ptelephone2 ||'><'|| Pemail||'>';
  nameprocedure := 'pr_update_developer';
  
  -- COMPROBACIN DE PARMETROS DE ENTRADA
  IF (Pdeveloperid IS NULL OR Pdeveloperid = '') THEN
    RAISE noDeveloperId;
  END IF; 
  
  ----Comprobamos que est dado de alta ( y sin fecha de baja)  
  SELECT COUNT(*) INTO aux FROM developers WHERE developerId = PdeveloperId;
  IF (aux=0)  THEN
    RAISE idNoExist;
  ELSE
    SELECT datedelete into baja FROM developers WHERE developerId = PdeveloperId;
    IF (baja IS NOT NULL) THEN
      RAISE idBaja;
    END IF;
  END IF;
  
   IF (PnameComp IS NULL OR PnameComp = '') THEN
    RAISE noNameCom;
  END IF;
  -- Comprobamos que no exista otra compaa con el mismo nombre
  SELECT COUNT(*) INTO aux2 FROM developers WHERE nameComp = PnameComp and developerid <> pdeveloperid;
  IF (aux2 = 1) THEN
    RAISE nameComExist;
  END IF;
 
  IF (PnameLegalRepres IS NULL OR PnameLegalRepres = '') THEN
    RAISE noNameLegalR;
  END IF;
  IF (PsurnameLegalRepres IS NULL OR PsurnameLegalRepres = '') THEN
    RAISE noSurnameLegalR;
  END IF;
  IF (PidCardRepres IS NULL OR PidCardRepres = '') THEN
    RAISE noIdCardR;
  END IF;
  IF (PcountryCode IS NULL OR PcountryCode = '') THEN
    RAISE noCodeCountry;
  END IF;
  IF (PheadOfficeAddress IS NULL OR PheadOfficeAddress = '') THEN
    RAISE noHOAddress;
  END IF;
  IF (PheadOfficeCity IS NULL OR PheadOfficeCity = '') THEN
    RAISE noHOCity;
  END IF;
  IF (PheadOfficeCp IS NULL OR PheadOfficeCp = '') THEN
    RAISE noHOCp;
  END IF;
  IF (PheadOfficeProvince IS NULL OR PheadOfficeProvince = '') THEN
    RAISE noHOProvince;
  END IF;
  IF (Ptelephone1 IS NULL OR Ptelephone1 = '') THEN
    RAISE noTelephone1;
  END IF;
  IF (Pemail IS NULL OR Pemail = '') THEN
    RAISE noHOEmail;
  END IF;

   -- Modificacin de los datos del programador
  UPDATE developers SET
      namecomp = pnamecomp,
      namelegalrepres = pnamelegalrepres,
      surnamelegalrepres = psurnamelegalrepres,
      idcardrepres = pidcardrepres,
      countrycode = Pcountrycode,
      headofficeaddress = pheadofficeaddress,
      headofficecity = pheadofficecity,
      headofficecp = pheadofficecp,
      headofficeprovince = pheadofficeprovince,
      telephone1 = ptelephone1,
      telephone2 = ptelephone2,
      email = pemail
  WHERE developerid = PdeveloperId;
  
   -- Modificacin correcta del nuevo programador
  pr_insert_logs (nameprocedure, paramin, resultpr); 
  
  
     -- CONTROL DE EXCEPCIONES
EXCEPTION
WHEN noDeveloperId THEN
  resultpr := 'ERROR: debe introducir un nmero de identificacin de la empresa';
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN idNoExist THEN
  resultpr := 'ERROR: El programador no existe';
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN idBaja THEN
  resultpr := 'ERROR: programador dado de baja';
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noNameCom THEN
  resultpr := 'ERROR: debe introducir un nombre';
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN nameComExist THEN
  resultpr := 'ERROR: el nombre de empresa ya existe con otro n de identificacin'; 
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noNameLegalR THEN
  resultpr := 'ERROR: debe introducir el nombre del Representante Legal'; 
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noIdCardR THEN
  resultpr := 'ERROR: debe introducir n del dni del Representante Legal'; 
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noSurnameLegalR THEN
  resultpr := 'ERROR: debe introducir el apellido del Representante Legal'; 
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noCodeCountry THEN
  resultpr := 'ERROR: debe introducir pas de origen';    
  pr_insert_logs (nameprocedure, paramin, resultpr);  
WHEN noHOAddress THEN
  resultpr := 'ERROR: debe introducir la direccin de las oficinas centrales';    
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noHOCity THEN
  resultpr := 'ERROR: debe introducir la ciudad de las oficinas centrales';    
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noHOCp THEN
  resultpr := 'ERROR: debe introducir el cdigo postal de las oficinas centrales';    
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noHOProvince THEN
  resultpr := 'ERROR: debe introducir la provincia de las oficinas centrales';    
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noTelephone1 THEN
  resultpr := 'ERROR: debe introducir el n de telfono de las oficinas centrales';    
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noHOEmail THEN
  resultpr := 'ERROR: debe introducir un email';   
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN OTHERS THEN
  err_num:= SQLCODE;
  err_msg := substr(SQLERRM, 1, 200);
  resultpr := 'ERROR: '|| TO_CHAR (err_num) || err_msg;
  pr_insert_logs (nameprocedure, paramin, resultpr);
 
  
end pr_update_developer;

/
------------------------------------------------------------------
-- PROCEDIMIENTO PARA DAR DE ALTA UN PROGRAMADOR
-- DATOS DE ENTRADA:
--    DEVELOPERID
--    NAMECOMP
--    NAMELEGALREPRES
--    SURNAMELEGALREPRES
--    IDCARDREPRES
--    COUNTRYCODE
--    HEADOFFICEADDRES
--    HEADOFFICECITY
--    HEADOFFICECP
--    TELEPHONE1
--    TELEPHONE2
--    EMAIL
-- DATOS DE SALIDA
--    RESULTPR (RSP)
----------------------------------------------------------------------
create or replace
procedure pr_insert_developer 
(
  Pdeveloperid in developers.developerid%type,
  PnameComp in developers.namecomp%type,
  PnameLegalRepres in developers.namelegalrepres%type,
  PsurnameLegalRepres in developers.surnamelegalrepres%type,
  PidCardRepres in developers.idcardrepres%type,
  PcountryCode in developers.countrycode%type,
  PheadOfficeAddress in developers.headofficeaddress%type,
  PheadOfficeCity in developers.headofficecity%type,
  PhedadOfficeCp in developers.headofficecp%type,
  PheadOfficeProvince in developers.headofficeprovince%type,
  Ptelephone1 in developers.telephone1%type,
  Ptelephone2 in developers.telephone2%type,
  Pemail in developers.email%type,
  resultpr out nocopy varchar2
)as 

--DECLARACIN DE VARIABLES
  nameprocedure logs.nameprocedure%type;
  paramin logs.paramin%type;
  cDateInsert developers.dateinsert%type;
  RSP		VARCHAR2(100);
  aux number(1);
  aux2 number(1);
  baja developers.datedelete%type;
    
  noDeveloperId EXCEPTION;
  idExist EXCEPTION;
  nameComExist EXCEPTION;
  noNameCom EXCEPTION;
  noNameLegalR EXCEPTION;
  noSurnameLegalR EXCEPTION;
  noIdCardR EXCEPTION;
  noCodeCountry EXCEPTION;
  noHOAddress EXCEPTION;
  noHOCity EXCEPTION;
  noHOCp EXCEPTION;
  noHOProvince EXCEPTION;
  noTelephone1 EXCEPTION;
  noHOEmail EXCEPTION;
  err_num        NUMBER;
  err_msg        VARCHAR2(3500);

begin
-- INICIALIZACIN DE VARIABLES
  resultpr := 'Ok';
  cDateInsert := SYSDATE;
  paramin := '<'|| Pdeveloperid ||'><'|| PnameComp ||'><'|| PnameLegalRepres ||'><'|| PsurnameLegalRepres ||'><'||
             PidCardRepres ||'><'|| PcountryCode ||'><'|| PheadOfficeAddress ||'><'||PheadOfficeCity ||'><'||
             PhedadOfficeCp ||'><'|| PheadOfficeProvince ||'><'|| Ptelephone1||'><'||Ptelephone2 ||'><'|| Pemail||'>';
  nameprocedure := 'pr_insert_developer';
  
  -- COMPROBACIN DE PARMETROS DE ENTRADA
  IF (Pdeveloperid IS NULL OR Pdeveloperid = '') THEN
    RAISE noDeveloperId;
  END IF; 
  
  ----Comprobamos que no est ya dado de alta ( y sin fecha de baja)  
  SELECT COUNT(*) INTO aux FROM developers WHERE developerId = PdeveloperId;
  IF (aux = 1)  THEN
    SELECT datedelete into baja FROM developers WHERE developerId = PdeveloperId;
    IF (baja is null) THEN
      RAISE idExist;
    END IF;
  END IF;
  
  
  IF (PnameComp IS NULL OR PnameComp = '') THEN
    RAISE noNameCom;
  END IF;
  -- Comprobamos que no exista otra compaa con el mismo nombre
  SELECT COUNT(*) INTO aux2 FROM developers WHERE nameComp = PnameComp;
  IF (aux2 = 1) THEN
    RAISE nameComExist;
  END IF;
 
  IF (PnameLegalRepres IS NULL OR PnameLegalRepres = '') THEN
    RAISE noNameLegalR;
  END IF;
  IF (PsurnameLegalRepres IS NULL OR PsurnameLegalRepres = '') THEN
    RAISE noSurnameLegalR;
  END IF;
  IF (PidCardRepres IS NULL OR PidCardRepres = '') THEN
    RAISE noIdCardR;
  END IF;
  IF (PcountryCode IS NULL OR PcountryCode = '') THEN
    RAISE noCodeCountry;
  END IF;
  IF (PheadOfficeAddress IS NULL OR PheadOfficeAddress = '') THEN
    RAISE noHOAddress;
  END IF;
  IF (PheadOfficeCity IS NULL OR PheadOfficeCity = '') THEN
    RAISE noHOCity;
  END IF;
  IF (PhedadOfficeCp IS NULL OR PhedadOfficeCp = '') THEN
    RAISE noHOCp;
  END IF;
  IF (PheadOfficeProvince IS NULL OR PheadOfficeProvince = '') THEN
    RAISE noHOProvince;
  END IF;
  IF (Ptelephone1 IS NULL OR Ptelephone1 = '') THEN
    RAISE noTelephone1;
  END IF;
  IF (Pemail IS NULL OR Pemail = '') THEN
    RAISE noHOEmail;
  END IF;
  
 -- Dar de alta un programador
    -- Si est dado de baja (existe el programador pero con fecha de baja) ser reactivar con los datos introducidos y fecha de alta actual
    -- Si no est dado de alta se har la insercin a la tabla (por defecto se inserta la fecha de alta a la actual)
  
 IF (baja is not null AND aux = 1) THEN
      RSP:= 'OK';
      update developers set datedelete = '' where developerId = PdeveloperId;
      pr_update_developer (Pdeveloperid, PnameComp,PnameLegalRepres,PsurnameLegalRepres,
      PidCardRepres,PcountryCode,PheadOfficeAddress,PheadOfficeCity,PhedadOfficeCp,
      PheadOfficeProvince,Ptelephone1,Ptelephone2,Pemail,RSP);
      resultpr :='Programador Reactivado';
  ELSE
    INSERT INTO developers
      ( developerId, namecomp, namelegalrepres, surnamelegalrepres, idcardrepres, countrycode,
        headofficeaddress, headofficecity, headofficecp, headofficeprovince, telephone1, telephone2,
        email, dateinsert)
        values
        (Pdeveloperid, PnameComp, PnameLegalRepres,PsurnameLegalRepres,
          PidCardRepres, PcountryCode,PheadOfficeAddress,PheadOfficeCity,
          PhedadOfficeCp,PheadOfficeProvince,Ptelephone1,Ptelephone2,
          Pemail, cDateInsert);
  END IF;
  
  
  -- se ha insertado/reactivado correctamente
  pr_insert_logs (nameprocedure, paramin, resultpr);
  
  
    -- CONTROL DE EXCEPCIONES
EXCEPTION
WHEN noDeveloperId THEN
  resultpr := 'ERROR: debe introducir un nmero de identificacin de la empresa';
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN idExist THEN
  resultpr := 'ERROR: programador ya dado de alta';
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noNameCom THEN
  resultpr := 'ERROR: debe introducir un nombre';
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN nameComExist THEN
  resultpr := 'ERROR: el nombre de empresa ya existe con otro n de identificacin'; 
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noNameLegalR THEN
  resultpr := 'ERROR: debe introducir el nombre del Representante Legal'; 
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noIdCardR THEN
  resultpr := 'ERROR: debe introducir n del dni del Representante Legal'; 
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noSurnameLegalR THEN
  resultpr := 'ERROR: debe introducir el apellido del Representante Legal'; 
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noCodeCountry THEN
  resultpr := 'ERROR: debe introducir pas de origen';    
  pr_insert_logs (nameprocedure, paramin, resultpr);  
WHEN noHOAddress THEN
  resultpr := 'ERROR: debe introducir la direccin de las oficinas centrales';    
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noHOCity THEN
  resultpr := 'ERROR: debe introducir la ciudad de las oficinas centrales';    
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noHOCp THEN
  resultpr := 'ERROR: debe introducir el cdigo postal de las oficinas centrales';    
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noHOProvince THEN
  resultpr := 'ERROR: debe introducir la provincia de las oficinas centrales';    
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noTelephone1 THEN
  resultpr := 'ERROR: debe introducir el n de telfono de las oficinas centrales';    
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noHOEmail THEN
  resultpr := 'ERROR: debe introducir un email';   
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN OTHERS THEN
  err_num:= SQLCODE;
  err_msg := substr(SQLERRM, 1, 200);
  resultpr := 'ERROR: '|| TO_CHAR (err_num) || err_msg;
  pr_insert_logs (nameprocedure, paramin, resultpr);
 
  

end pr_insert_developer;
/

----------------------------------------------------------------------------------
-- PROCEDIMIENTO PARA DAR DE BAJA (INSERTAR FECHA BAJA) A UN PROGRAMADOR
--  DATOS DE ENTRADA:
--    IDDEVELOPER
--  DATOS DE SALIDA:
--    RESULTPR (RSP)
-------------------------------------------------------------------------------------
create or replace
procedure pr_delete_developer
(Pdeveloperid in developers.developerid %type,
resultpr out nocopy varchar2)
as 
-- DECLARACIN DE VARIABLES
  cDateDelete DATE;  
  aux number(1);
  baja developers.datedelete%type;
  nameprocedure logs.nameprocedure%type;
  paramin logs.paramin%type;
    
  noDeveloperId EXCEPTION;
  idNoExist EXCEPTION;
  idDeleted EXCEPTION;
  err_num  NUMBER;
  err_msg  VARCHAR2(3500);
  
  
BEGIN
--INICIALIZACIN DE VARIABLES
  resultpr := 'Ok';
  cDateDelete := SYSDATE;
  paramin := '<'||pdeveloperid||'>';
  nameprocedure := 'pr_delete_developer';
             
   -- COMPROBACIN DE PARMETROS DE ENTRADA
  IF (pdeveloperid IS NULL OR pdeveloperid = '') THEN
    RAISE noDeveloperId;
  END IF;
  
  ----Comprobamos que est dado de alta ( y sin fecha de baja)  
  SELECT COUNT(*) INTO aux FROM developers WHERE developerid = pdeveloperid;
  IF (aux = 1)  THEN
    SELECT datedelete into baja FROM developers WHERE developerid = pdeveloperid;
    IF (baja is not null) THEN
      RAISE idDeleted;
    END IF;
  ELSE
    RAISE idNoExist;
  END IF;
  
   
    -- Dar de baja el usuario (Ingresar fecha de baja, por motivos de histricos no se borrar el registro)
      
    UPDATE developers SET datedelete = cDateDelete WHERE developerid = pdeveloperid;
    
    -- "Borrado" o fecha de baja del usuario insertada correctamente
    pr_insert_logs (nameprocedure, paramin, resultpr); 
  
 
  -- CONTROL DE EXCEPCIONES
EXCEPTION
WHEN noDeveloperId THEN
  resultpr := 'ERROR: debe introducir un nmero de identificacin';
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN idNoExist THEN
  resultpr := 'ERROR: el programador no existe';
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN idDeleted THEN
  resultpr := 'ERROR: el programador ya est dado de baja';
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN OTHERS THEN
  err_num:= SQLCODE;
  err_msg := substr(SQLERRM, 1, 200);
  resultpr := 'ERROR: '|| TO_CHAR (err_num) || err_msg;
  pr_insert_logs (nameprocedure, paramin, resultpr);

end pr_delete_developer;
/


----------------------------------------------------------------------------------
-- PROCEDIMIENTO PARA MODIFICAR UN USUARIO
--  DATOS DE ENTRADA:
--    IDCARD
--    NAMEU
--    SURNAME
--    DATEBIRTH
--    MOBILENUMBER
--    TELEPHONEOP
--    CODECOUNTRY 
--    MAIL
--  DATOS DE SALIDA:
--    RESULTPR (RSP)
----------------------------------------------------------------
create or replace
procedure pr_update_user 
(
    PidCard in users.idcard%TYPE,
    PnameU in users.nameuser%TYPE,
    Psurname in users.surnameuser%TYPE,
    PdateBirth in users.datebirth%TYPE,
    PmobileNumber  in users.mobilenumber%TYPE,
    PtelephoneOp in users.ciftelephoneop%TYPE,
    PcodeCountry in users.codecountry%TYPE,
    Pmail in users.mail%TYPE,
    resultpr out nocopy varchar2
)as 
-- DECLARACIN DE VARIABLES
  edad number(3);
  aux number(1);
  baja users.datedelete%type;
  nameprocedure logs.nameprocedure%type;
  paramin logs.paramin%type;
    
  noIdCard EXCEPTION;
  IdNoExist EXCEPTION;
  idBaja EXCEPTION;
  noName EXCEPTION;
  noSurname EXCEPTION;
  noDateBirth EXCEPTION;
  noValidAgeUser EXCEPTION;
  noMobileNumber EXCEPTION;
  noTelephoneOp EXCEPTION;
  noCodeCountry EXCEPTION;
  noMail EXCEPTION;
  err_num        NUMBER;
  err_msg        VARCHAR2(3500);
  
begin
--INICIALIZACIN DE VARIABLES
  resultpr := 'Ok';
  paramin := '<'|| pidcard ||'><'|| pnameu ||'><'|| psurname ||'><'|| pdatebirth ||'><'||
             pmobilenumber ||'><'|| ptelephoneop ||'><'|| pcodecountry ||'><'||pmail ||'>';
  nameprocedure := 'pr_update_user';
             
   -- COMPROBACIN DE PARMETROS DE ENTRADA
  IF (PidCard IS NULL OR PidCard = '') THEN
    RAISE noIdCard;
  END IF;
  ----Comprobamos que est ya dado de alta (y no de baja)
  SELECT COUNT(*) INTO aux FROM users WHERE idCard = PidCard;
  IF (aux=0)  THEN
    RAISE idNoExist;
  ELSE
    SELECT datedelete into baja FROM users WHERE idCard = PidCard;
    IF (baja IS NOT NULL) THEN
      RAISE idBaja;
    END IF;
  END IF;
  
  IF (PnameU IS NULL OR PnameU = '') THEN
    RAISE noName;
  END IF;
  
  IF (Psurname IS NULL OR Psurname = '') THEN
    RAISE noSurname;
  END IF;
  
  IF (PdateBirth IS NULL OR PdateBirth = '') THEN
    RAISE noDateBirth;
  END IF;
  ----Comprobamos que el usuario sea mayor de edad
  edad := floor(months_between(sysdate, PdateBirth)/12); 
  IF (edad < 18) THEN
    RAISE noValidAgeUser;
  END IF; 
  
  IF (PmobileNumber IS NULL OR PmobileNumber = 0) THEN
    RAISE noMobileNumber;
  END IF;
  
  IF (PtelephoneOp IS NULL OR PtelephoneOp = '') THEN
    RAISE noTelephoneOp;
  END IF;
  
  IF (PcodeCountry IS NULL OR PcodeCountry = '') THEN
    RAISE noCodeCountry;
  END IF;
  
  IF (Pmail IS NULL OR Pmail = '') THEN
    RAISE noMail;
  END IF;
  
    -- Modificacin de los datos del usuario
  UPDATE users SET
      nameuser = PnameU,
      surnameuser =Psurname,
      dateBirth = PdateBirth,
      mobileNumber= PmobileNumber,
      ciftelephoneOp=PtelephoneOp ,
      codeCountry= PcodeCountry,
      mail= Pmail
  WHERE idCard = PidCard;
  
   -- Modificacin correcta del nuevo usuario
  pr_insert_logs (nameprocedure, paramin, resultpr); 

 
  -- CONTROL DE EXCEPCIONES
EXCEPTION
 
WHEN noIdCard THEN
  resultpr := 'ERROR: debe introducir un nmero de identidad';
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN idNoExist THEN
  resultpr := 'ERROR: el usuario no existe';
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN idBaja THEN
  resultpr := 'ERROR: el usuario est dado de baja';
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noName THEN
  resultpr := 'ERROR: debe introducir un nombre';
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noSurname THEN
  resultpr := 'ERROR: debe introducir apellido'; 
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noDateBirth THEN
  resultpr := 'ERROR: debe introducir la fecha de nacimiento'; 
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noValidAgeUser THEN
  resultpr := 'ERROR: el usuario debe ser mayor de edad';    
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noMobileNumber THEN
  resultpr := 'ERROR: debe introducir su nmero mvil';    
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noTelephoneOp THEN
  resultpr := 'ERROR: debe introducir su operador telefnico';    
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noCodeCountry THEN
  resultpr := 'ERROR: debe introducir pas de origen';    
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noMail THEN
  resultpr := 'ERROR: debe introducir un email';   
  pr_insert_logs (nameprocedure, paramin, resultpr);

WHEN OTHERS THEN
  err_num:= SQLCODE;
  err_msg := substr(SQLERRM, 1, 200);
  resultpr := 'ERROR: '|| TO_CHAR (err_num) || err_msg;
  pr_insert_logs (nameprocedure, paramin, resultpr);

end pr_update_user;
/

----------------------------------------------------------------------------------
-- PROCEDIMIENTO PARA DAR DE ALTA UN USUARIO
--  DATOS DE ENTRADA:
--    IDCARD
--    NAMEU
--    SURNAME
--    DATEBIRTH
--    MOBILENUMBER
--    TELEPHONEOP
--    CODECOUNTRY 
--    MAIL
--    IMEI
--    DEVICEMODEL
--  DATOS DE SALIDA:
--    RESULTPR (RSP)
----------------------------------------------------------------

create or replace
procedure pr_insert_user 
(
    PidCard in users.idcard%TYPE,
    PnameU in users.nameuser%TYPE,
    Psurname in users.surnameuser%TYPE,
    PdateBirth in users.datebirth%TYPE,
    PmobileNumber  in users.mobilenumber%TYPE,
    PtelephoneOp in users.ciftelephoneop%TYPE,
    PcodeCountry in users.codecountry%TYPE,
    Pmail in users.mail%TYPE,
    Pimei in device.imei%TYPE,
    PdeviceModel in device.devicemodel%TYPE,
    resultpr out nocopy varchar2
)as 
-- DECLARACIN DE VARIABLES
  cDateInsert DATE;  
  cYear number(4);
  cUsersNum number;
  edad number(3);
  aux number(1);
  auxM number (1);
  baja users.datedelete%type;
  nameprocedure logs.nameprocedure%type;
  paramin logs.paramin%type;
  RSP		VARCHAR2(100);
    
  noIdCard EXCEPTION;
  IdExist EXCEPTION;
  noName EXCEPTION;
  noSurname EXCEPTION;
  noDateBirth EXCEPTION;
  noValidAgeUser EXCEPTION;
  noMobileNumber EXCEPTION;
  mobileNumberExist EXCEPTION;
  noTelephoneOp EXCEPTION;
  noCodeCountry EXCEPTION;
  noMail EXCEPTION;
  noImei EXCEPTION;
  imeiNoValid EXCEPTION;
  noDeviceModel EXCEPTION;
  err_num        NUMBER;
  err_msg        VARCHAR2(3500);
  
begin
--INICIALIZACIN DE VARIABLES
  resultpr := 'Ok';
  cDateInsert := SYSDATE;
  paramin := '<'|| pidcard ||'><'|| pnameu ||'><'|| psurname ||'><'|| pdatebirth ||'><'||
             pmobilenumber ||'><'|| ptelephoneop ||'><'|| pcodecountry ||'><'||pmail ||'><'||
             pimei ||'><'|| pdevicemodel ||'>';
  nameprocedure := 'pr_insert_user';
             
   -- COMPROBACIN DE PARMETROS DE ENTRADA
  IF (PidCard IS NULL OR PidCard = '') THEN
    RAISE noIdCard;
  END IF;
  
  ----Comprobamos que no est ya dado de alta ( y sin fecha de baja)  
  SELECT COUNT(*) INTO aux FROM users WHERE idCard = PidCard;
  IF (aux = 1)  THEN
    SELECT datedelete into baja FROM users WHERE idCard = PidCard;
    IF (baja is null) THEN
      RAISE idExist;
    END IF;
  END IF;
  
  IF (PnameU IS NULL OR PnameU = '') THEN
    RAISE noName;
  END IF;
  
  IF (Psurname IS NULL OR Psurname = '') THEN
    RAISE noSurname;
  END IF;
  
  IF (PdateBirth IS NULL OR PdateBirth = '') THEN
    RAISE noDateBirth;
  END IF;
  ----Comprobamos que el usuario sea mayor de edad
  edad := floor(months_between(sysdate, PdateBirth)/12); 
  IF (edad < 18) THEN
    RAISE noValidAgeUser;
  END IF; 
  
  IF (PmobileNumber IS NULL OR PmobileNumber = 0) THEN
    RAISE noMobileNumber;
  END IF;
 --Comprobamos que no exista ningn usuario (dado de alta) con el mismo mvil 
  SELECT count(idCard) INTO auxM FROM users WHERE (mobileNumber = PmobileNumber AND datedelete is null);
  IF (auxM=1) THEN
    RAISE mobileNumberExist;
  END IF;
  
  IF (PtelephoneOp IS NULL OR PtelephoneOp = '') THEN
    RAISE noTelephoneOp;
  END IF;
  
  IF (PcodeCountry IS NULL OR PcodeCountry = '') THEN
    RAISE noCodeCountry;
  END IF;
  
  IF (Pmail IS NULL OR Pmail = '') THEN
    RAISE noMail;
  END IF;
  IF (Pimei IS NULL OR Pimei = 0) THEN
    RAISE noImei;
  END IF;
  --- comprueba que sea un imei vlido (15 dgitos)
  IF ((length(Pimei)<>15)) THEN
    RAISE imeiNoValid;
  END IF;
  
  IF (PdeviceModel IS NULL OR PdeviceModel = '') THEN
    RAISE noDeviceModel;
  END IF;
  
  
    -- Dar de alta usuario:
    -- Si est dado de baja (existe el usuario pero con fecha de baja) ser reactivar con los datos introducidos y fecha de alta actual
    -- Si no est dado de alta se har la insercin a la tabla (por defecto se inserta la fecha de alta a la actual y el campo firsBuy a 'S')
  
 IF (baja is not null AND aux = 1) THEN
      RSP:= 'OK';
      update users set datedelete = '' where idcard= PidCard;
      pr_update_user (PidCard, PnameU,Psurname,PdateBirth,PmobileNumber,
      PtelephoneOp,PcodeCountry,Pmail,RSP);
      
      resultpr :='Usuario Reactivado';
  ELSE
    INSERT INTO USERS
      (
        idCard,
        nameUser,
        surnameuser,
        dateBirth,
        mobileNumber,
        ciftelephoneOp,
        codeCountry,
        mail,
        dateInsert
      )
      VALUES
      (
        PidCard,
        PnameU,
        Psurname,
        PdateBirth,
        PmobileNumber,
        PtelephoneOp,
        PcodeCountry,
        Pmail,
        cDateInsert
      );
    
    END IF;
    
    --INSERCIN DEL DISPOSITIVO CON EL QUE EL USUARIO SE DA DE ALTA
    
    --- Si el dispositivo no est dado de alta se inserta, si ya est dado de alta
    --- se cambia el usuario al que pertenece
    SELECT COUNT(*) INTO aux FROM device WHERE imei = Pimei;
    IF (aux=1)  THEN
      update device  set idCardUser = PidCard where imei=Pimei;
    ELSE 
      insert into device 
      (
        imei,
        idCardUser,
        deviceModel)
      values
      (
        Pimei,
        PidCard,
        PdeviceModel);
    END IF;
    -- Inserccin correcta del nuevo usuario
    pr_insert_logs (nameprocedure, paramin, resultpr); 
  
  -- ACTUALIZAMOS LA TABLA ESTADSTICA es_year
  -- Sumar 1 al n de usuarios de en la tabla de estadsticas por ao es_year y volver
  -- a calcular la media. Si el registro del ao actual todava no existe, se crea.
    SELECT to_number(to_char(sysdate, 'YYYY')) INTO cyear from dual;
    SELECT COUNT(eyear)INTO aux FROM es_year WHERE eyear= cyear;
    IF (aux = 0) THEN
      SELECT COUNT (idCard) INTO cUsersNum FROM users WHERE dateDelete is null;
      INSERT INTO es_year (eyear, usersnum, appNum, mediaDownUsers, topDeveloper, developeDownNum,
                            topApp, topAppDeveloper,topappversion, topappos)
                  VALUES (cyear, cUsersNum, 0, 0.0, '', 0, '', '','','');
    ELSE
       UPDATE es_year SET usersnum = usersNum +1, mediaDownUsers = appNum/(usersNum+1) WHERE eyear = cyear;
    END IF;
 
  -- CONTROL DE EXCEPCIONES
EXCEPTION
WHEN noIdCard THEN
  resultpr := 'ERROR: debe introducir un nmero de identidad';
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN idExist THEN
  resultpr := 'ERROR: usuario ya dado de alta';
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noName THEN
  resultpr := 'ERROR: debe introducir un nombre';
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noSurname THEN
  resultpr := 'ERROR: debe introducir apellido'; 
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noDateBirth THEN
  resultpr := 'ERROR: debe introducir la fecha de nacimiento'; 
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noValidAgeUser THEN
  resultpr := 'ERROR: el usuario debe ser mayor de edad';    
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noMobileNumber THEN
  resultpr := 'ERROR: debe introducir su nmero mvil';    
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noTelephoneOp THEN
  resultpr := 'ERROR: debe introducir su operador telefnico';    
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noCodeCountry THEN
  resultpr := 'ERROR: debe introducir pas de origen';    
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noMail THEN
  resultpr := 'ERROR: debe introducir un email';   
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noImei THEN
  resultpr := 'ERROR: debe introducir el nmero imei de su dispositivo';   
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN imeiNoValid THEN
  resultpr := 'ERROR: nmero imei del dispositivo no vlido';   
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN noDeviceModel THEN
  resultpr := 'ERROR: debe introducir el modelo de dispositivo';   
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN  mobileNumberExist THEN
  resultpr := 'ERROR: ya existe un usuario dado de alta con ese nmero de mvil';   
  pr_insert_logs (nameprocedure, paramin, resultpr); 
 
WHEN OTHERS THEN
  err_num:= SQLCODE;
  err_msg := substr(SQLERRM, 1, 200);
  resultpr := 'ERROR: '|| TO_CHAR (err_num) || err_msg;
  pr_insert_logs (nameprocedure, paramin, resultpr);

end pr_insert_user;
/
----------------------------------------------------------------------------------
-- PROCEDIMIENTO PARA DAR DE BAJA (INSERTAR FECHA DE BAJA) DE UN USUARIO
--  DATOS DE ENTRADA:
--    IDCARD
--  DATOS DE SALIDA:
--    RESULTPR (RSP)
----------------------------------------------------------------
create or replace
procedure pr_delete_user 
(Pidcard in users.idcard%type,
resultpr out nocopy varchar2)
as 
-- DECLARACIN DE VARIABLES
  cDateDelete DATE;  
  cYear number(4);
  cUsersNum number;
  aux number(1);
  baja users.datedelete%type;
  nameprocedure logs.nameprocedure%type;
  paramin logs.paramin%type;
    
  noIdCard EXCEPTION;
  idNoExist EXCEPTION;
  idDeleted EXCEPTION;
  err_num  NUMBER;
  err_msg  VARCHAR2(3500);
  
begin
--INICIALIZACIN DE VARIABLES
  resultpr := 'Ok';
  cDateDelete := SYSDATE;
  paramin := '<'|| pidcard ||'>';
  nameprocedure := 'pr_delete_user';
             
   -- COMPROBACIN DE PARMETROS DE ENTRADA
  IF (PidCard IS NULL OR PidCard = '') THEN
    RAISE noIdCard;
  END IF;
  
  ----Comprobamos que est dado de alta ( y sin fecha de baja)  
  SELECT COUNT(*) INTO aux FROM users WHERE idCard = PidCard;
  IF (aux = 1)  THEN
    SELECT datedelete into baja FROM users WHERE idCard = PidCard;
    IF (baja is not null) THEN
      RAISE idDeleted;
    END IF;
  ELSE
    RAISE idNoExist;
  END IF;
  
   
    -- Dar de baja el usuario (Ingresar fecha de baja, por motivos de histricos no se borrar el registro)
      
    UPDATE users SET datedelete = cDateDelete WHERE idcard= PidCard;
    
     -- ACTUALIZAMOS LA TABLA ESTADSTICA es_year
  -- Restar 1 al n de usuarios de en la tabla de estadsticas por ao es_year y volver
  -- a calcular la media. Si el registro del ao actual todava no existe, se crea.
    SELECT to_number(to_char(sysdate, 'YYYY')) INTO cyear from dual;
    SELECT COUNT(eyear)INTO aux FROM es_year WHERE eyear= cyear;
    IF (aux = 0) THEN
      SELECT COUNT (idCard) INTO cUsersNum FROM users WHERE dateDelete is null;
      INSERT INTO es_year (eyear, usersnum, appNum, mediaDownUsers, topDeveloper, developeDownNum,
                            topApp, topAppDeveloper,topappversion, topappos)
                  VALUES (cyear, cUsersNum, 0, 0, '', 0, '', '','','');
    ELSE
       UPDATE es_year SET usersnum = usersNum -1, mediaDownUsers = appNum/(usersNum-1) WHERE eyear = cyear;
    END IF;
    
    -- "Borrado" o fecha de baja del usuario insertada correctamente
    pr_insert_logs (nameprocedure, paramin, resultpr); 
  
 
  -- CONTROL DE EXCEPCIONES
EXCEPTION
WHEN noIdCard THEN
  resultpr := 'ERROR: debe introducir un nmero de identidad';
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN idNoExist THEN
  resultpr := 'ERROR: el usario no existe';
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN idDeleted THEN
  resultpr := 'ERROR: el usuario ya est dado de baja';
  pr_insert_logs (nameprocedure, paramin, resultpr);
WHEN OTHERS THEN
  err_num:= SQLCODE;
  err_msg := substr(SQLERRM, 1, 200);
  resultpr := 'ERROR: '|| TO_CHAR (err_num) || err_msg;
  pr_insert_logs (nameprocedure, paramin, resultpr);
end pr_delete_user;

/


---------------------------------------------------------------------------
-- PROCEDIMIENTO QUE SE EJECUTA CUANDO UN USUARIO HACE UNA DESCARGA
-- DATOS DE ENTRADA:
--  IDCARDU, APPIDENTIF, NAMEOS, PAYWAY, IMEI
-- DATOS DE SALIDA:
--  RESULTPR (RSP)
----------------------------------------------------------------------------
create or replace
procedure pr_regdownloads 
(PidCardU in downloads.idcarduser%type,
 PappIdentif in downloads.appidentif%type,
 PnameOS in downloads.nameos%type,
 PpayWay in downloads.payway%type,
 Pimei in downloads.imei%type,
 resultpr OUT NOCOPY Varchar2
)as 

-- DECLARACIN DE VARIABLES
	nameprocedure logs.nameprocedure%type;
	paramin logs.paramin%type;
	aux number;
  aux2 number;
  err_num NUMBER;
	err_msg VARCHAR2(3500);
  
  verapp applications.versionapp%type;
  cc users.codecountry%type;
  cdatedown downloads.datedown%type;
  cApp appDevelope.appIdentif%type;
  cprice downloads.price%type;
  
  --ccodecountry downloads.codecountry%type;
  cTelephoneOp downloads.idtelephoneop%type;
  cyear es_year.eyear%type;
  cUsersNum es_year.usersnum%type;
  cdevelopeDownNum number;
  cTopDeveloper es_year.topDeveloper%type;
  cdevelope appdevelope.developerid%type;
  cTopApp es_year.topapp%type;
  cTopAppVersion es_year.topAppVersion%type;
  ctopAppOs es_year.topAppOs%type;
  cTopAppDevelope es_year.topappdeveloper%type;
  cTopAppDevelope1 developers.nameComp%type;
  cAppNum es_year.appNum%type;
  cmediaDownUsers es_year.mediaDownUsers%type;
  tot number;
  
  noIdCard EXCEPTION;
  noAppIdentif  EXCEPTION;
  noNameOs  EXCEPTION;
  noPayWay  EXCEPTION;
  noImei  EXCEPTION;
  noAppOS EXCEPTION;
  noPriceCountry EXCEPTION;
  
  -- Cursor para guardar cTopAppDevelope en es_year
  CURSOR listDevelopers IS
    SELECT DEVELOPERS.NAMECOMP FROM APPDEVELOPE LEFT JOIN DEVELOPERS
      ON DEVELOPERS.DEVELOPERID = APPDEVELOPE.DEVELOPERID
      WHERE AppIdentif=cTopApp AND versionApp=ctopAppVersion AND nameOs=ctopAppOs;
  
begin

--Inicializacin de variables
  cdatedown := SYSDATE;
  nameprocedure := 'pr_regdownloads';
	paramin := ('<'||PidCardU ||'><'||PappIdentif ||'><'||PnameOS ||'><'||PpayWay ||'><'||Pimei||'>');
  resultpr:='Ok';
-- Comprobamos variables de entrada
 IF (PidCardU IS NULL OR PidCardU = '') THEN
    RAISE noIdCard;
 END IF;
 IF (PappIdentif IS NULL OR PappIdentif = '') THEN
    RAISE noAppIdentif;
 END IF;
 IF (PnameOS IS NULL OR PnameOS = '') THEN
    RAISE noNameOs;
 END IF;  
 IF (PpayWay IS NULL OR PpayWay = '') THEN
    RAISE noPayWay;
 END IF;
 IF (Pimei IS NULL OR Pimei = '') THEN
    RAISE noImei;
 END IF;
 --Comprobamos que exista la aplicacin para el sistema operativo solicitado
 SELECT count(appIdentif) into aux FROM applications WHERE (appIdentif = PappIdentif AND nameOS = PnameOS AND active='S');
 IF (aux = 0) THEN
    RAISE noAppOs;
 END IF;
 

  

-- Sacamos la versin activa, operador telefnico y el cdigo del pas del usuario
SELECT ap.versionApp,  u.codecountry, u.ciftelephoneop INTO  verapp, cc, cTelephoneOP 
    FROM applications ap, users u 
    WHERE (ap.appidentif = PappIdentif AND ap.active = 'S' AND ap.nameos = pnameos AND u.idcard = pidcardu );

-- Comprobamos que est disponible en el pas de registro del usuario
 SELECT count(appidentif) INTO aux FROM price WHERE (appIdentif = PappIdentif AND nameOS = PnameOS 
     AND versionApp = verapp AND codeCountry = (SELECT codeCountry FROM users WHERE idCard = PidCardU));
 IF (aux= 0) THEN
    RAISE noPriceCountry;
 END IF;

-- Calculamos el precio. Si es una descarga de una misma aplicacin (misma versin o no) en 
-- un mismo dispositivo (mismo imei) el precio de la descarga ser 0
SELECT count(imei) INTO aux FROM downloads WHERE (appidentif = PappIdentif AND imei = Pimei);
IF (aux <> 0) THEN
  cprice := 0;
ELSE
  SELECT price INTO cprice FROM price WHERE (appIdentif = pappidentif AND versionapp = verapp AND nameOS = PnameOS AND codeCountry = cc);
END IF;


-- Registramos la decarga
INSERT INTO downloads (appidentif, versionapp, nameos, idCardUser, dateDown, payWay, price, codeCountry, imei, idTelephoneOP)
    VALUES (PappIdentif, verapp, PnameOs, PidCardU, cdatedown, PpayWay, cprice, cc, Pimei, cTelephoneOp);
    
-- Ejecucin correcta
pr_insert_logs(nameprocedure, paramin, resultpr);

-- ACTUALIZAMOS LA TABLA ESTADSTICA es_total
--------------------------------------------------
-- ** el nico registro de esta tabla se crea al insertar los datos manuales, tambin
--    se podra insertar al crear la tabla.
    
   UPDATE es_total SET totaldownloads = totaldownloads+1, totaleuros = totaleuros + cprice;
   
-- ACTUALIZAMOS LA TABLA ESTADSTICA es_year
-----------------------------------------------
 SELECT to_number(to_char(sysdate, 'YYYY')) INTO cyear from dual;

-- Si todava no existe registro para el ao actual se crea
    SELECT COUNT(eyear)INTO aux FROM es_year WHERE eyear= cyear;
    IF (aux = 0) THEN
      SELECT COUNT (idCard) INTO cUsersNum FROM users WHERE dateDelete is null;

      INSERT INTO es_year (eyear, usersnum)
                  VALUES (cyear, cUsersNum);
    END IF;
    
--1)le sumamos al n de descargas realizadas y actualizamos la media
    UPDATE es_year SET appnum=appnum+1, mediadownusers=(appnum+1)/usersnum;
  
-- 2) Actualizamos el programador que tiene mayor nmero de descargas y el nmero.
--    Si ha cambiado se modifica tanto el programador como el nmero de descargas, 
--    sino se aade 1 al nmero de descargas
    
    SELECT * INTO cdevelope FROM (
    SELECT d.nameComp FROM developers d
      JOIN appDevelope ad ON ad.developerid = d.developerid
      WHERE appIdentif = PappIdentif AND versionApp = verApp AND nameOs = PnameOs
    ) WHERE ROWNUM=1; 
   
    SELECT COUNT(*) INTO aux FROM es_year WHERE topappdeveloper = cdevelope AND eyear = cyear;
 
    IF (aux = 1) THEN
      UPDATE es_year SET developeDownNum = developeDownNum+1;
    ELSE
          SELECT tot, Comp INTO cDevelopeDownNum, cTopDeveloper FROM    
          (SELECT COUNT(d.appidentif)as tot, dv.nameComp as Comp FROM 
          ((SELECT * FROM downloads WHERE substr(dateDown,1,9) BETWEEN '01-ENE-'||cyear AND '31-DIC-'||cyear) d
          LEFT JOIN appdevelope ad ON d.appidentif = ad.appidentif AND d.versionapp = ad.versionapp 
          AND d.nameos=ad.nameos) LEFT JOIN developers dv ON ad.developerid =dv.developerid
          GROUP BY ad.developerid, dv.nameComp)
          WHERE ROWNUM=1; 
          
          UPDATE es_year SET developeDownNum=cdevelopeDownNum, topDeveloper=cTopDeveloper;
   
      END IF;
    
  -- 3) Actualizamos la aplicacin que ms dinero ha generado en descargas, as como su programador
    SELECT COUNT(*) INTO aux FROM es_year WHERE eyear=cyear AND topApp = PappIdentif AND topAppVersion = verApp
                        AND topAppOs = PnameOs;   
    IF (aux=0) THEN
      SELECT appIdentif, versionApp, nameOs INTO cTopApp, ctopAppVersion, ctopAppOs  FROM (SELECT appIdentif , versionApp, nameOS, SUM(price) AS tot FROM downloads
        WHERE price >0 AND substr(dateDown,1,9) BETWEEN '01-ENE-'||cyear AND '31-DIC-'||cyear
        GROUP BY appIdentif, versionApp, nameOs
        ORDER BY tot DESC) WHERE ROWNUM=1;
      BEGIN
        OPEN listDevelopers;
        LOOP FETCH listDevelopers INTO cTopAppDevelope1;
        EXIT WHEN listDevelopers%NOTFOUND;      
          cTopAppDevelope := cTopAppDevelope ||cTopAppDevelope1 || ', ';
        END LOOP;
        CLOSE listDevelopers;
      END;
      aux := length (rtrim(cTopAppDevelope))-1;
      UPDATE es_year SET topApp = cTopApp, topAppVersion = ctopAppVersion, topAppOs=ctopAppOs, 
                 topAppDeveloper= substr(cTopAppDevelope,1,aux)
                  WHERE eyear=cyear;
    END IF;
  
  
  -- ACTUALIZAMOS LA TABLA ESTADSTICA es_yearCountry
---------------------------------------------------------

-- Si todava no existe registro para el ao actual y pas se crea
   SELECT COUNT(eyear)INTO aux FROM es_yearCountry WHERE eyear= cyear AND country = cc;
    IF (aux = 0) THEN
      INSERT INTO es_yearCountry (eyear, country, minUsersNum, totalIncome, appDifDownNum)
                  VALUES (cyear, cc, 0,0,0);
    END IF;
-- Si es la primera descarga del ao del usuario se suma 1 a minUsersNum
-- Si el importe de la descarga es >0 sumamos el importe a totalIncome
-- Si es la primera descarga de la aplicacin se suma 1 a appDifDownNum
    SELECT COUNT(idCardUser) INTO aux FROM downloads WHERE idCardUser = pidCardU AND (substr(dateDown,1,9) BETWEEN '01-ENE-'||cyear AND '31-DIC-'||cyear) AND codeCountry = cc;
    SELECT COUNT(appIdentif) INTO aux2 FROM downloads WHERE appIdentif = PappIdentif AND (substr(dateDown,1,9) BETWEEN '01-ENE-'||cyear AND '31-DIC-'||cyear) AND codeCountry = cc ;
    IF (aux =1) THEN
      IF (cprice>0) THEN
        IF (aux2=1) THEN
            UPDATE es_yearCountry SET minUsersNum = minUsersNum+1, totalIncome=totalIncome + cprice,
              appDifDownNum = appDifDownNum + 1 WHERE eyear = cyear AND country = cc; 
        ELSE
            UPDATE es_yearCountry SET minUsersNum = minUsersNum+1, totalIncome=totalIncome + cprice
               WHERE eyear = cyear AND country = cc; 
        END IF;
      ELSE 
        IF (aux2=1) THEN
           UPDATE es_yearCountry SET minUsersNum = minUsersNum+1, appDifDownNum = appDifDownNum + 1 
              WHERE eyear = cyear AND country = cc; 
        ELSE
            UPDATE es_yearCountry SET minUsersNum = minUsersNum+1 WHERE eyear = cyear AND country = cc; 
        END IF;
      END IF;
    ELSE
      IF (cprice>0) THEN
        IF (aux2=1) THEN
            UPDATE es_yearCountry SET totalIncome=totalIncome + cprice,
              appDifDownNum = appDifDownNum + 1 WHERE eyear = cyear AND country = cc; 
        ELSE
            UPDATE es_yearCountry SET totalIncome=totalIncome + cprice
               WHERE eyear = cyear AND country = cc; 
        END IF;
      ELSE 
        IF (aux2=1) THEN
           UPDATE es_yearCountry SET appDifDownNum = appDifDownNum + 1
              WHERE eyear = cyear AND country = cc; 
       END IF;
    END IF;
 END IF;
    
           

 --TRATAMIENTO DE EXCEPCIONES
EXCEPTION 
	WHEN noIdCard THEN
		resultpr := 'ERROR: Debe introducir n de identificacin de usuario';
		pr_insert_logs(nameprocedure, paramin, resultpr);
 	WHEN noAppIdentif THEN
		resultpr := 'ERROR: Debe introducir nombre de aplicacin';
		pr_insert_logs(nameprocedure, paramin, resultpr);  
	WHEN noNameOs THEN
		resultpr := 'ERROR: Debe introducir el sistema operativo';
		pr_insert_logs(nameprocedure, paramin, resultpr);  
  WHEN noPayWay THEN
		resultpr := 'ERROR: Debe introducir la forma de pago';
		pr_insert_logs(nameprocedure, paramin, resultpr); 
  WHEN noImei THEN
		resultpr := 'ERROR: Debe introducir el n imei del dispositivo';
		pr_insert_logs(nameprocedure, paramin, resultpr); 
  WHEN noAppOS THEN
    resultpr := 'ERROR: No est disponible la aplicacin y sistema operativo solicitado';
    pr_insert_logs(nameprocedure, paramin, resultpr);
  WHEN noPriceCountry THEN
    resultpr := 'ERROR: No est a la venta en el pas del usuario';
    pr_insert_logs(nameprocedure, paramin, resultpr);
  WHEN OTHERS THEN
		err_num := SQLCODE;
		err_msg := substr(SQLERRM, 1, 255);
		resultpr := 'ERROR: ' || TO_CHAR(err_num) || '->' || err_msg ;
			pr_insert_logs(nameprocedure, paramin, resultpr);

end pr_regdownloads;
/

--------------------------------------------------------------------------------
-- LISTADO DE TODOS LOS PROGRAMADORES DE UN PAS DADO CON TODOS SUS DATOS
--INCLUYENDO EL NMERO  DE APLICACIONES DIFERENTES PUBLICADAS
-- DATOS DE ENTRADA
--           CODGO DE PAS
--------------------------------------------------------------------------------
create or replace
procedure pr_list_dev_country
  (Pcountry IN countries.codecountry%TYPE,
	resultpr OUT NOCOPY Varchar2
)
IS
-- DECLARACIN DE VARIABLES
	nameprocedure logs.nameprocedure%type;
	paramin logs.paramin%type;
  nameCountry countries.country_name%type;
  
  developerid developers.developerid%type;
  namecomp developers.namecomp%type; 
  nameLegalR developers.namelegalrepres%type;
  surnameLegalR developers.surnamelegalrepres%type;
  idCardR developers.idcardrepres%type;
  countryCode developers.countrycode%type;
  HOAddress developers.headofficeaddress%type;
  HOCity developers.headofficecity%type;
  HOCp developers.headofficecp%type;
  HOProvince developers.headofficeprovince%type;
  tlf1 developers.telephone1%type;
  tlf2 developers.telephone2%type;
  email developers.email%type;
  dateinsert developers.dateinsert%type;
  datedelete developers.datedelete%type;
  numapli number;
    
	
	err_num NUMBER;
	err_msg VARCHAR2(255);

	noCountry EXCEPTION;
	
-- Cursor donde se almacena el resultado de la consulta
	CURSOR listDev IS
	SELECT d.*, app.numapli FROM 
    developers d , 
    (SELECT developerid, count(developerid) as numapli from 
        (SELECT distinct appidentif, nameos, developerid from appdevelope group by (appidentif,nameos, developerid)) group by developerid) app 
  where (d.countrycode = Pcountry and d.developerid = app.developerid);
  
  
  
  
BEGIN
 --Inicializamos variables
	resultpr:='OK';
  nameprocedure := 'pr_list_dev_country';
  paramin := '<'||Pcountry||'>';
  
	-- VERIFICAMOS PARMETROS DE ENTRADA

	IF (Pcountry IS NULL OR Pcountry ='') THEN
		RAISE noCountry;
	END IF;
  -- Recuperamos el nombre del pas
  SELECT country_name INTO nameCountry FROM countries WHERE codecountry = Pcountry;

	-- Cabecera
	DBMS_OUTPUT.PUT_LINE('');
	DBMS_OUTPUT.PUT_LINE('-----------------------------------------------------------------');
	DBMS_OUTPUT.PUT_LINE('           Listado de  Programadores de '|| nameCountry ||'    ');
  DBMS_OUTPUT.PUT_LINE('              con el n de aplicaciones desarrolladas        ');  
	DBMS_OUTPUT.PUT_LINE('-----------------------------------------------------------------');
	   
	
 	BEGIN
	-- Tratamiento del cursor
		OPEN listDev;
		LOOP
		FETCH listDev INTO developerid, namecomp, nameLegalR, surnameLegalR, idCardR, countryCode, HOAddress,
                        HOCity, HOCp, HOProvince, tlf1, tlf2, email, dateinsert, datedelete, numapli;	
		EXIT WHEN listDev%NOTFOUND;
			DBMS_OUTPUT.PUT_LINE('Programador: '||RPAD(developerid,15)||RPAD(namecomp,20));
      DBMS_OUTPUT.PUT_LINE('Representante Legal: '||nameLegalR||' '||surnameLegalR||' con n ident. '|| idCArdR);
      DBMS_OUTPUT.PUT_LINE('Direccin:'||HOAddress||'. '||HOCity||'('||HOCp||' '||HOProvince||')');
      DBMS_OUTPUT.PUT_LINE('Telfonos: '||tlf1||' /'||tlf2||' Email: '||email);
      DBMS_OUTPUT.PUT_LINE('Fecha de alta: '||dateinsert||' Fecha de baja: '||datedelete);
      DBMS_OUTPUT.PUT_LINE('N app programadas: '||numapli);
      DBMS_OUTPUT.PUT_LINE(' ');
		END LOOP;
		CLOSE listDev;
	DBMS_OUTPUT.PUT_LINE(' ');		  
	END;
	
	-- Ejecucin correcta
	pr_insert_logs(nameprocedure, paramin, resultpr);
  
  --TRATAMIENTO DE EXCEPCIONES
EXCEPTION 
	WHEN noCountry THEN
		resultpr := 'ERROR: Pas inexistente';
		pr_insert_logs(nameprocedure, paramin, resultpr);
  
  	WHEN OTHERS THEN
		err_num := SQLCODE;
		err_msg := SQLERRM;
		resultpr := 'ERROR: ' || TO_CHAR(err_num) || '->' || err_msg ;
			pr_insert_logs(nameprocedure, paramin, resultpr);

end pr_list_dev_country;
/

--------------------------------------------------------------------------------
--          Listado de  Programadores de todas las aplicaciones    
--             activas ordenadas por el n total de descargas        
--              (solo contabilizan las que generan ingresos     
-- DATOS DE ENTRADA: ---
--------------------------------------------------------------------------------
create or replace
procedure pr_list_ranking_downloads 
(resultpr OUT NOCOPY Varchar2)
as 
-- DECLARACIN DE VARIABLES
	nameprocedure logs.nameprocedure%type;
	paramin logs.paramin%type;
  appIdentif applications.appidentif%type;
  versionApp applications.versionapp%type;
  nameOs applications.nameos%type;
  dateUp date;
  minResoScreen applications.minresoscreen%type;
  sizeApp applications.sizeapp%type;
  linkApp applications.linkapp%type;
  active applications.active%type;
  dateDelete applications.datedelete%type;
  total number;
  
  
  err_num NUMBER;
	err_msg VARCHAR2(255);
  
CURSOR listRankDown IS
SELECT  app.*, d.total FROM 
-- tabla applications filtrado 
 (SELECT * FROM applications WHERE active = 'S') app JOIN     
-- tabla totales downloads          
(SELECT appidentif, nameOS, count(appidentif) as total FROM downloads  WHERE price <> 0 
GROUP BY (appidentif, nameOS))d
ON app.appidentif = d.appidentif
ORDER BY d.total DESC;

BEGIN
--Inicializamos variables
	resultpr:='OK';
  nameprocedure := 'pr_list_ranking_downloads';
  paramin := '<'||'>';
  
  -- Cabecera
	DBMS_OUTPUT.PUT_LINE('');
	DBMS_OUTPUT.PUT_LINE('--------------------------------------------------------------------------------');
	DBMS_OUTPUT.PUT_LINE('                  Listado de todas las aplicaciones    ');
  DBMS_OUTPUT.PUT_LINE('             activas ordenadas por el n total de descargas       ');  
	DBMS_OUTPUT.PUT_LINE('--------------------------------------------------------------------------------');
	DBMS_OUTPUT.PUT_LINE('Aplicacin      Vers.  Sis.Operativo     Fecha subida   Resol.mn   Tamao Link             Total');
     
  	BEGIN
	-- Tratamiento del cursor
		OPEN listRankDown;
		LOOP
		FETCH listRankDown INTO appIdentif, versionApp, nameOs, dateUp, minResoScreen, sizeApp, linkApp, 
                            active, dateDelete, total;	
		EXIT WHEN listRankDown%NOTFOUND;

		    DBMS_OUTPUT.PUT_LINE(RPAD(appIdentif,16)||RPAD(versionApp,7)|| RPAD(nameOs,18)|| RPAD(dateup,15)
                        || RPAD(minResoScreen,12)|| RPAD(sizeApp,7)|| RPAD(linkApp, 18 )|| total);	

		END LOOP;
		CLOSE listRankDown;
	
	END;
-- Ejecucin correcta
	pr_insert_logs(nameprocedure, paramin, resultpr);
  --TRATAMIENTO DE EXCEPCIONES
EXCEPTION 
  	WHEN OTHERS THEN
		err_num := SQLCODE;
		err_msg := SQLERRM;
		resultpr := 'ERROR: ' || TO_CHAR(err_num) || '->' || err_msg ;
			pr_insert_logs(nameprocedure, paramin, resultpr);


END pr_list_ranking_downloads;
/
-------------------------------------------------------------------------------
--           Listado de  los pases donde se ha descargado una     
--             aplicacin dada en un ao dado 
--              (solo contabilizan las que generan ingresos) 
-- DATOS DE ENTRADA: APPIDENTIF, YEAR
--------------------------------------------------------------------------------
create or replace
procedure pr_list_down_year_countries 
(PappIdentif IN applications.appidentif%TYPE,
 Pyear number,
	resultat OUT NOCOPY Varchar2
)
as
-- DECLARACIN DE VARIABLES
	nameprocedure logs.nameprocedure%type;
	paramin logs.paramin%type;
	resultpr logs.resultpr%type;
  d_start varchar2(8);
  d_end varchar2(8);
  totalCountry number;
  country countries.country_name%type;
  total number;
  
  err_num NUMBER;
	err_msg VARCHAR2(255);

	noAppIdentif EXCEPTION;
  noYear EXCEPTION;
  
  CURSOR ListDownYearApp IS
   SELECT co.country_name, s.totalCountry FROM
    (SELECT codeCountry, COUNT(codeCountry) AS totalCountry
      FROM downloads WHERE substr(dateDown,1,9) BETWEEN ('01-ENE-'|| substr(Pyear,3,2)) AND ('31-DIC-'|| substr (Pyear,3,2)) AND appIdentif= pappIdentif AND price <>0
      GROUP BY codecountry) s JOIN countries co 
      ON s.codeCountry = co.codecountry;
   	  
BEGIN
--Inicializamos variables
  resultpr:='OK';
  nameprocedure := 'pr_down_app_year_countries';
  paramin :='<'|| PappIdentif||'><'||Pyear||'>';

  -- COMPROBACIN DE PARMETROS DE ENTRADA
  IF (PappIdentif IS NULL OR PappIdentif = '') THEN
    RAISE noAppIdentif;
  END IF;
   IF (Pyear IS NULL OR Pyear = '') THEN
    RAISE noYear;
  END IF;
 
  
  -- Cabecera
	DBMS_OUTPUT.PUT_LINE('');
	DBMS_OUTPUT.PUT_LINE('--------------------------------------------------------------------------------');
	DBMS_OUTPUT.PUT_LINE('           Listado de  los pases donde se ha descargado la     ');
  DBMS_OUTPUT.PUT_LINE('             aplicacin '|| pappIdentif ||'durante el ao '||Pyear     );  
  DBMS_OUTPUT.PUT_LINE('              (solo contabilizan las que generan ingresos)        ');  
	DBMS_OUTPUT.PUT_LINE('--------------------------------------------------------------------------------');
	DBMS_OUTPUT.PUT_LINE('Pas             Total Descargas'); 
  
   	BEGIN
	-- Tratamiento del cursor
		OPEN ListDownYearApp;
		LOOP
		FETCH ListDownYearApp INTO country, total;	
		EXIT WHEN ListDownYearApp%NOTFOUND;

		    DBMS_OUTPUT.PUT_LINE(RPAD(country,19)|| total);	

		END LOOP;
		CLOSE ListDownYearApp;
	
	END;
-- Ejecucin correcta
	pr_insert_logs(nameprocedure, paramin, resultpr);
  
  EXCEPTION
 WHEN noAppIdentif THEN
		resultpr := 'ERROR: Debe introducir una aplicacin';
		pr_insert_logs(nameprocedure, paramin, resultpr);
    
   WHEN noYear THEN
		resultpr := 'ERROR: El ao solicitado no es vlido';
		pr_insert_logs(nameprocedure, paramin, resultpr);
  
  	WHEN OTHERS THEN
		err_num := SQLCODE;
		err_msg := SQLERRM;
		resultpr := 'ERROR: ' || TO_CHAR(err_num) || '->' || err_msg ;
		pr_insert_logs(nameprocedure, paramin, resultpr);
     
  END pr_list_down_year_countries;
  /
  -----------------------------------------------------------------------------
  -- LISTADO DE LAS DESCARGAS REALIZADAS POR UN USUARIO
  -- IDENTIFICADO POR SU N DE TELFONO
  -- DATOS DE ENTRADA: N TELFONO USUARIO
  -----------------------------------------------------------------------------
create or replace
procedure pr_list_down_user  
  (PmobileNumber IN users.mobilenumber%TYPE,
	resultpr OUT NOCOPY Varchar2
)
as
-- DECLARACIN DE VARIABLES
	nameprocedure logs.nameprocedure%type;
	paramin logs.paramin%type;
	
  cidcard users.idcard%type;
  cnameUser users.nameuser%type;
  csurnameUser users.surnameUser%type;
  ccountry countries.country_name%type;
  
  appIdentif downloads.appidentif%type;
  versionApp downloads.versionapp%type;
  nameOS downloads.nameos%type;
  idCardUser downloads.idcarduser%type;
  dateDown date;
  payWay downloads.payway%type;
  price downloads.price%type;
  codeCountry downloads.codecountry%type;
  imei downloads.imei%type;
  idTelephoneOp downloads.idtelephoneop%type;
     
	
	err_num NUMBER;
	err_msg VARCHAR2(255);

	noMobileNumber EXCEPTION;
  
  -- Cursor donde se almacena el resultado de la consulta
	CURSOR listDesU IS
	SELECT d.* , c.country_name FROM 
    (SELECT * FROM downloads WHERE idCardUser = cidCard) d JOIN countries c
    ON d.codeCountry = c.codecountry ;
  
  BEGIN
  
-- Inicializacin de variables
  nameprocedure := 'pr_list_down_user';
	paramin := '<'||PmobileNumber||'>';
	resultpr :='Ok';
  
  SELECT idCard, nameUser, surnameUser INTO cidCard, cnameUser, csurnameUser FROM users WHERE mobileNumber = PmobileNumber;  
	
    -- Comprobamos las variables de entrada
  IF (PmobileNumber IS NULL OR PmobileNumber ='') THEN
		RAISE noMobileNumber;
	END IF;
  
	  
	-- Cabecera
	DBMS_OUTPUT.PUT_LINE('');
	DBMS_OUTPUT.PUT_LINE('-----------------------------------------------------------------');
	DBMS_OUTPUT.PUT_LINE(' Listado de Descargas de '|| cnameUser ||' '||csurnameUser);
  DBMS_OUTPUT.PUT_LINE('-----------------------------------------------------------------');
	DBMS_OUTPUT.PUT_LINE(RPAD('Fecha',10)||' '||RPAD('Aplicacin',13)||' '||RPAD ('Vers.',6)||' '||RPAD('Sis.Ope.',15)||' '||RPAD('Pas',10)
    ||RPAD('',5)||' '||RPAD('Pay Way',10)||RPAD('Dispositivo',15)||' '||RPAD('Comp. Telef.',15));
 
 	BEGIN
	-- Tratamiento del cursor
		OPEN listDesU;
		LOOP
		FETCH listDesU INTO appidentif, versionApp, nameOS, idCardUser, dateDown, payWay, price, codeCountry, imei, idTelephoneOP, ccountry;	
		EXIT WHEN listDesU%NOTFOUND;
	      DBMS_OUTPUT.PUT_LINE(RPAD(dateDown,11)||' '||RPAD(appidentif,12)||' '||RPAD(versionApp,6)||' '||RPAD(nameOS,15)||' '||RPAD(ccountry,8)
        ||' '||RPAD(price,6)||' '||RPAD(payWay,9)||' '||RPAD(imei,15)||' '||RPAD(idTelephoneOP, 10));

		END LOOP;
		CLOSE listDesU;
	DBMS_OUTPUT.PUT_LINE(' ');		  
	END;
	
	-- Ejecucin correcta
	pr_insert_logs(nameprocedure, paramin, resultpr);
  
  --TRATAMIENTO DE EXCEPCIONES
EXCEPTION 
	WHEN noMobileNumber THEN
		resultpr:= 'ERROR: debe introducir un n de mbil';
		pr_insert_logs(nameprocedure, paramin, resultpr);
  
  	WHEN OTHERS THEN
		err_num := SQLCODE;
		err_msg := SQLERRM;
		resultpr := 'ERROR: ' || TO_CHAR(err_num) || '->' || err_msg ;
			pr_insert_logs(nameprocedure, paramin, resultpr);

end pr_list_down_user;
/
-----------------------------------------------------------------
--  LISTADO DE LOS 20 USUARIOS CON MS GASTO EN DESCARGAS
--  DURANTE UN AO DADO
-- DATOS DE ENTRADA: AO
-------------------------------------------------------------------
 create or replace procedure pr_list_top20_users_year 
(Pyear in number,
 resultpr OUT NOCOPY Varchar2)
as 
-- DECLARACIN DE VARIABLES
	nameprocedure logs.nameprocedure%type;
	paramin logs.paramin%type;
  idCard users.idcard%type;
  nameU users.nameuser%type;
  surnameU users.surnameuser%type;
  euros number;
  
  noYear EXCEPTION;
  
  err_num NUMBER;
	err_msg VARCHAR2(255);
  
   -- Cursor donde se almacena el resultado de la consulta
	CURSOR listTop20 IS
   SELECT s.idCardUser, u.nameUser, u.surnameUser, s.total FROM
    (SELECT idCardUser, total FROM (SELECT idCardUser, SUM(price) AS total FROM downloads
          WHERE substr(dateDown,1,9) BETWEEN ('01-ENE-'|| substr(Pyear,3,2)) AND ('31-DIC-'|| substr (Pyear,3,2)) AND  price <>0
          GROUP BY idCardUser 
          ORDER BY total DESC) WHERE ROWNUM < 21) s 
    JOIN users u
     ON s.idCardUser = u.idcard;
  
BEGIN
-- Inicializacin de variables
  nameprocedure := 'pr_top20_users_year';
	paramin := '<'||Pyear||'>';
	resultpr :='Ok';
  
  -- Comprobamos las variables de entrada
  IF (Pyear IS NULL OR Pyear ='') THEN
		RAISE noYear;
	END IF;
  
 -- Cabecera
	DBMS_OUTPUT.PUT_LINE('');
	DBMS_OUTPUT.PUT_LINE('-----------------------------------------------------------------');
	DBMS_OUTPUT.PUT_LINE('         Listado de los 20 usuarios con mayor gasto ');
  	DBMS_OUTPUT.PUT_LINE('            en descargas durante '||Pyear);
  DBMS_OUTPUT.PUT_LINE('-----------------------------------------------------------------');
	DBMS_OUTPUT.PUT_LINE(RPAD('IdCard ',15)||' '||RPAD('Nombre',20)||' '||RPAD ('Apellido',20)||' '||'Gastado');
  DBMS_OUTPUT.PUT_LINE('----------------------------------------------------------------- ');	
 	BEGIN
	-- Tratamiento del cursor
		OPEN listTop20;
		LOOP
		FETCH listTop20 INTO idCard, nameU, surnameU, euros;	
		EXIT WHEN listTop20%NOTFOUND;
	      DBMS_OUTPUT.PUT_LINE(RPAD(idCard,15)||' '||RPAD(nameU,20)||' '||RPAD(surnameU,20)||' '||euros);

		END LOOP;
		CLOSE listTop20;
		  
	END;
	
	-- Ejecucin correcta
	pr_insert_logs(nameprocedure, paramin, resultpr); 
  
  
  
  
  
 --TRATAMIENTO DE EXCEPCIONES
EXCEPTION 
	WHEN noYear THEN
		resultpr:= 'ERROR: debe introducir un ao (4 dgitos)';
		pr_insert_logs(nameprocedure, paramin, resultpr);
  
  	WHEN OTHERS THEN
		err_num := SQLCODE;
		err_msg := SQLERRM;
		resultpr := 'ERROR: ' || TO_CHAR(err_num) || '->' || err_msg ;
			pr_insert_logs(nameprocedure, paramin, resultpr);
      
end pr_list_top20_users_year;

----------------------------------------------------------------------------
-- TRIGGER TR_COUNTRIES
-- PARA REGISTRO EN LA TABLA LOGS DE LAS ABM EN LA TABLA COUNTRIES
----------------------------------------------------------------------------
create or replace
trigger tr_countries
after insert or delete or update on countries 
for each row 
declare
  paramamin varchar2(20000);
BEGIN
IF (inserting) THEN
  paramamin := :new.codecountry||','||:new.country_name||','||:new.currency;
  INSERT INTO logs (nameprocedure,paramin,resultpr,datatime) VALUES ('insert_countries',paramamin,'ok',sysdate);
END IF;
IF (updating) THEN
  paramamin := :new.codecountry||','||:new.country_name||','||:new.currency;
  INSERT INTO logs (nameprocedure,paramin,resultpr,datatime) VALUES ('update_countries',paramamin,'ok',sysdate);
END IF;
IF (deleting) THEN
  paramamin := :old.codecountry||','||:old.country_name||','||:old.currency;
  INSERT INTO logs (nameprocedure,paramin,resultpr,datatime) VALUES ('delete_countries',paramamin,'ok',sysdate);
END IF;
END;

----------------------------------------------------------------------------
-- TRIGGER TR_CURRENCY
-- PARA REGISTRO EN LA TABLA LOGS DE LAS ABM EN LA TABLA CURRENCY
----------------------------------------------------------------------------
create or replace
trigger tr_currency
after insert or delete or update on currency 
for each row 
declare
  paramamin varchar2(20000);
BEGIN
IF (inserting) THEN
  paramamin := :new.currency;
  INSERT INTO logs (nameprocedure,paramin,resultpr,datatime) VALUES ('insert_currency',paramamin,'ok',sysdate);
END IF;
IF (updating) THEN
  paramamin := :new.currency;
  INSERT INTO logs (nameprocedure,paramin,resultpr,datatime) VALUES ('update_currency',paramamin,'ok',sysdate);
END IF;
IF (deleting) THEN
  paramamin := :old.currency;
  INSERT INTO logs (nameprocedure,paramin,resultpr,datatime) VALUES ('delete_currency',paramamin,'ok',sysdate);
END IF;
END;

----------------------------------------------------------------------------
-- TRIGGER TR_DEVICEMODEL
-- PARA REGISTRO EN LA TABLA LOGS DE LAS ABM EN LA TABLA DEVICEMODEL
----------------------------------------------------------------------------
create or replace
trigger tr_devicemodel
after insert or delete or update on devicemodel
for each row 
declare
  paramamin varchar2(20000);
BEGIN
IF (inserting) THEN
  paramamin := :new.devicemodel||','||:new.manufacturer;
  INSERT INTO logs (nameprocedure,paramin,resultpr,datatime) VALUES ('insert_devicemodel',paramamin,'ok',sysdate);
END IF;
IF (updating) THEN
  paramamin := :new.devicemodel||','||:new.manufacturer;
  INSERT INTO logs (nameprocedure,paramin,resultpr,datatime) VALUES ('update_devicemodel',paramamin,'ok',sysdate);
END IF;
IF (deleting) THEN
  paramamin := :old.devicemodel||','||:old.manufacturer;
  INSERT INTO logs (nameprocedure,paramin,resultpr,datatime) VALUES ('delete_devicemodel',paramamin,'ok',sysdate);
END IF;
END;

----------------------------------------------------------------------------
-- TRIGGER TR_OSYSTEM
-- PARA REGISTRO EN LA TABLA LOGS DE LAS ABM EN LA TABLA OSYSTEM
----------------------------------------------------------------------------
create or replace
trigger tr_oSystem
after insert or delete or update on oSystem 
for each row 
declare
  paramamin varchar2(20000);
BEGIN
IF (inserting) THEN
  paramamin := :new.nameos;
  INSERT INTO logs (nameprocedure,paramin,resultpr,datatime) VALUES ('insert_oSystem',paramamin,'ok',sysdate);
END IF;
IF (updating) THEN
  paramamin := :new.nameos;
  INSERT INTO logs (nameprocedure,paramin,resultpr,datatime) VALUES ('update_oSystem',paramamin,'ok',sysdate);
END IF;
IF (deleting) THEN
  paramamin := :old.nameos;
  INSERT INTO logs (nameprocedure,paramin,resultpr,datatime) VALUES ('delete_oSystem',paramamin,'ok',sysdate);
END IF;
END;

----------------------------------------------------------------------------
-- TRIGGER TR_TELEPHONEOP
-- PARA REGISTRO EN LA TABLA LOGS DE LAS ABM EN LA TABLA TELEPHONEOP
----------------------------------------------------------------------------
create or replace
trigger tr_telephoneop 
after insert or delete or update on telephoneop 
for each row 
declare
  paramamin varchar2(20000);
BEGIN
IF (inserting) THEN
  paramamin := :new.ciftelephoneOp||','||:new.nametelephoneOP||','||:new.nameglobalop;
  INSERT INTO logs (nameprocedure,paramin,resultpr,datatime) VALUES ('insert_telephoneop',paramamin,'ok',sysdate);
END IF;
IF (updating) THEN
  paramamin := :new.ciftelephoneOp||','||:new.nametelephoneOP||','||:new.nameglobalop;
  INSERT INTO logs (nameprocedure,paramin,resultpr,datatime) VALUES ('update_telephoneop',paramamin,'ok',sysdate);
END IF;
IF (deleting) THEN
  paramamin := :old.ciftelephoneOp||','||:old.nametelephoneOP||','||:old.nameglobalop;
  INSERT INTO logs (nameprocedure,paramin,resultpr,datatime) VALUES ('delete_telephoneop',paramamin,'ok',sysdate);
END IF;
END;

/