set serveroutput on;
----------------------------------------------------------------------------------------
-- JUEGO DE PRUEBAS PARA PROCEDIMIENTOS DE ABM USERS
---------------------------------------------------------------------------------------
DECLARE
	RSP		VARCHAR2(100);
BEGIN

	RSP:= 'OK';
  
  
----------------------------------------------------------------------------------------
-- ########   JUEGO DE PRUEBAS PARA EL PROCEDIMIENTO PR_INSERT_USER    ################
----------------------------------------------------------------------------------------

-- Comprobacin Error noIdCard (no se introduce idCard de usuario)
pr_insert_user ('','Usuario error','Apellidos Usuario Error','15-SEP-1964',345345345,'E111111111', 'ES','usuarioError@gmail.com', 666666666666666, 'iPhone4',RSP);

-- Comprobacin Error idExist (se introduce un idCard ya registrado)
pr_insert_user ('111111111A','Usuario error','Apellidos Usuario Error','15-SEP-1964',345345345,'E111111111', 'ES','usuarioError@gmail.com', 666666666666666, 'iPhone4',RSP);

-- Comprobacin Error noName (no se introduce nombre de usuario)
pr_insert_user ('666666666A','','Apellidos Usuario Error','15-SEP-1964',345345345,'E111111111', 'ES','usuarioError@gmail.com', 666666666666666, 'iPhone4',RSP);

-- Comprobacin Error noSurname (no se introduce apellidos de usuario)
pr_insert_user ('666666666A','Usuario error','','15-SEP-1964',345345345,'E111111111', 'ES','usuarioError@gmail.com', 666666666666666, 'iPhone4',RSP);

-- Comprobacin Error noDateBirth (no se introduce fecha de nacimiento de usuario)
pr_insert_user ('666666666A','Usuario error','Apellidos Usuario Error','',345345345,'E111111111', 'ES','usuarioError@gmail.com', 666666666666666, 'iPhone4',RSP);

-- Comprobacin Error noValidAgeUser (el usuario no es mayor de 18 aos)
pr_insert_user ('666666666A','Usuario error','Apellidos Usuario Error','15-SEP-1999',345345345,'E111111111', 'ES','usuarioError@gmail.com', 666666666666666, 'iPhone4',RSP);

-- Comprobacin Error noMobileNumbre (no se introduce nmero mvil de usuario)
pr_insert_user ('666666666A','Usuario error','Apellidos Usuario Error','15-SEP-1964','','E111111111', 'ES','usuarioError@gmail.com', 666666666666666, 'iPhone4',RSP);

-- Comprobacin Error mobileNumberExist (el nmero de mvil ya existe)
pr_insert_user ('666666666A','Usuario error','Apellidos Usuario Error','15-SEP-1964',121212121,'E111111111', 'ES','usuarioError@gmail.com', 666666666666666, 'iPhone4',RSP);

-- Comprobacin Error noTelephoneOp (no se introduce operador telefnico de usuario)
pr_insert_user ('666666666A','Usuario error','Apellidos Usuario Error','15-SEP-1964',345345345,'', 'ES','usuarioError@gmail.com', 666666666666666, 'iPhone4',RSP);

-- Comprobacin Error noCodeCountry (no se introduce cdigo de pas de usuario)
pr_insert_user ('666666666A','Usuario error','Apellidos Usuario Error','15-SEP-1964',345345345,'E111111111', '','usuarioError@gmail.com', 666666666666666, 'iPhone4',RSP);

-- Comprobacin Error noMail (no se introduce mail de usuario)
pr_insert_user ('666666666A','Usuario error','Apellidos Usuario Error','15-SEP-1964',345345345,'E111111111', 'ES','', 666666666666666, 'iPhone4',RSP);

-- Comprobacin Error noImei (no se introduce imei de dispositivo de usuario)
pr_insert_user ('666666666A','Usuario error','Apellidos Usuario Error','15-SEP-1964',345345345,'E111111111', 'ES','usuarioError@gmail.com', '', 'iPhone4',RSP);

-- Comprobacin Error imeiNoValid (el imei introducido no tiene los 15 dgitos)
pr_insert_user ('666666666A','Usuario error','Apellidos Usuario Error','15-SEP-1964',345345345,'E111111111', 'ES','usuarioError@gmail.com', 666666666666, 'iPhone4',RSP);

-- Comprobacin Error noDeviceModel (no se introduce el modelo del dispositivo)
pr_insert_user ('666666666A','Usuario error','Apellidos Usuario Error','15-SEP-1964',345345345,'E111111111', 'ES','usuarioError@gmail.com', 666666666666666, '',RSP);

-- Un usuario se da de alta con un dispositivo ya dado de alta. Debe cambiar el usuario al que pertene (har una llamada a pr_update_user)
pr_insert_user ('666666666A','Nombre usuario6','Apellidos Usuario6','15-SEP-1964',456456456,'E111111111', 'ES','usuario5@gmail.com', 666666666666666, 'iPhone4',RSP);

-- Si el usuario estaba dado de baja se reactiva con los nuevos datos
pr_insert_user ('333333333A','Reac Nombre usuario3','Reac Apellidos Usuario3','19-SEP-1985',343434343,'E222222222', 'ES','usuario3@gmail.com', 333333333333333, 'iPhone5',RSP);


----------------------------------------------------------------------------------------
-- ########   JUEGO DE PRUEBAS PARA EL PROCEDIMIENTO PR_DELETE_USER    ################
----------------------------------------------------------------------------------------

-- Comprobacin Error noIdCard (no se recibe idCard de usuario para dar de baja)
pr_delete_user ('',RSP);

-- Comprobacin Error idNoExist (el idCard de usuario para dar de baja no existe)
pr_delete_user ('999999999A',RSP);

-- Comprobacin Error idDeleted (el idCard de usuario para dar de baja ya se haba dado de baja)
pr_delete_user ('444444444A',RSP);


----------------------------------------------------------------------------------------
-- ########   JUEGO DE PRUEBAS PARA EL PROCEDIMIENTO PR_UPDATE_USER    ################
----------------------------------------------------------------------------------------

-- Comprobacin Error noIdCard (no se ha introducido idCard de usuario a modificar)
pr_update_user ('','Nombre usuario2','Apellidos Usuario2','15-ENE-1971',232323232,'E111111111', 'ES','usuario2@gmail.com',RSP);

-- Comprobacin Error idNoExist (el idCard de usuario a modificar est dado de baja)
pr_update_user ('777777777A','Nombre usuario2','Apellidos Usuario2','15-ENE-1971',232323232,'E111111111', 'ES','usuario2@gmail.com',RSP);

-- Comprobacin Error idBaja (no existe el idCard de usuario a modificar)
pr_update_user ('444444444A','New Nombre usuario4','Apellidos Usuario4','15-OCT-1974',123123123,'F222222222', 'FR','usuario4@gmail.com', RSP);

-- Comprobacin Error noName (no se ha introducido nombre de usuario a modificar)
pr_update_user ('222222222A','','Apellidos Usuario2','15-ENE-1971',232323232,'E111111111', 'ES','usuario2@gmail.com',RSP);

-- Comprobacin Error noSurname (no se ha introducido apellidos de usuario a modificar)
pr_update_user ('222222222A','Nombre usuario2','','15-ENE-1971',232323232,'E111111111', 'ES','usuario2@gmail.com',RSP);

-- Comprobacin Error noDateBirth (no se ha introducido fecha de nacimiento de usuario a modificar)
pr_update_user ('222222222A','Nombre usuario2','Apellidos Usuario2','',232323232,'E111111111', 'ES','usuario2@gmail.com',RSP);

-- Comprobacin Error noValidAgeUser (el usuario a modificar no es mayor de 18 aos)
pr_update_user ('222222222A','Nombre usuario2','Apellidos Usuario2','15-ENE-2003',232323232,'E111111111', 'ES','usuario2@gmail.com',RSP);

-- Comprobacin Error noMobileNumber (no se ha introducido nmero de mvil de usuario a modificar)
pr_update_user ('222222222A','Nombre usuario2','Apellidos Usuario2','15-ENE-1971','','E111111111', 'ES','usuario2@gmail.com',RSP);

-- Comprobacin Error noTelephoneOp (no se ha introducido operador telefnico de usuario a modificar)
pr_update_user ('222222222A','Nombre usuario2','Apellidos Usuario2','15-ENE-1971',232323232,'', 'ES','usuario2@gmail.com',RSP);

-- Comprobacin Error noCodeCountry (no se ha introducido cdigo de pas de usuario a modificar)
pr_update_user ('222222222A','Nombre usuario2','Apellidos Usuario2','15-ENE-1971',232323232,'E111111111', '','usuario2@gmail.com',RSP);

-- Comprobacin Error noMail (no se ha introducido email de usuario a modificar)
pr_update_user ('222222222A','Nombre usuario2','Apellidos Usuario2','15-ENE-1971',232323232,'E111111111', 'ES','',RSP);
 
  
END;
/

select * FROM logs WHERE nameProcedure like 'pr_%_user';