set serveroutput on;
----------------------------------------------------------------------------------------
-- JUEGO DE PRUEBAS PARA PROCEDIMIENTOS DE ABM DEVELOPERS
---------------------------------------------------------------------------------------
DECLARE
	RSP		VARCHAR2(100);
BEGIN

	RSP:= 'OK';
  
----------------------------------------------------------------------------------------
-- ########   JUEGO DE PRUEBAS PARA EL PROCEDIMIENTO PR_INSERT_DEVELOPER    ################
----------------------------------------------------------------------------------------
-- Comprobar error noDeveloperId (no se ha introducido id del programador)
pr_insert_developer ('','Developer 1','Nombre Rep. Dev1','Apellido Rep. Dev1','111111111D','ES','Direccin dev1',
                    'ciudad dev1',11111,'Provincia dev1', 111111111,'','comDev1@dev.com',RSP);
                    
-- Comprobar error idExist (ya existe un programador con ese nmero id)
pr_insert_developer ('D11111111','Developer 1','Nombre Rep. Dev1','Apellido Rep. Dev1','111111111D','ES','Direccin dev1',
                    'ciudad dev1',11111,'Provincia dev1', 111111111,'','comDev1@dev.com',RSP);

-- Comprobar error noNameCom (no se ha introducido Nombre de la compaa del programador)
pr_insert_developer ('D55555555','','Nombre Rep. Dev5','Apellido Rep. Dev5','555555555D','ES','Direccin dev5',
                    'ciudad dev5',55555,'Provincia dev5', 555555555,'','comDev5@dev.com',RSP);

-- Comprobar error nameComExist (ya existe una compaa con el mismo nombre)
pr_insert_developer ('D55555555','New Developer 1','Nombre Rep. Dev1','Apellido Rep. Dev1','111111111D','ES','Direccin dev1',
                    'ciudad dev1',11111,'Provincia dev1', 111111111,'','comDev1@dev.com',RSP);
                    
-- Comprobar error noNameLegarlR (no se ha introducido el nombre del representante legal del programador)
pr_insert_developer ('D55555555','Developer 5','','Apellido Rep. Dev5','555555555D','ES','Direccin dev5',
                    'ciudad dev5',55555,'Provincia dev5', 555555555,'','comDev5@dev.com',RSP);

-- Comprobar error noSurnameLegarlR (no se ha introducido el apellido del representante legal del programador)
pr_insert_developer ('D55555555','Developer 5','Nombre Rep. Dev5','','555555555D','ES','Direccin dev5',
                    'ciudad dev5',55555,'Provincia dev5', 555555555,'','comDev5@dev.com',RSP);

-- Comprobar error noIdCardR (no se ha introducido el idCard del representante legal del programador)
pr_insert_developer ('D55555555','Developer 5','Nombre Rep. Dev5','Apellido Rep. Dev5','','ES','Direccin dev5',
                    'ciudad dev5',55555,'Provincia dev5', 555555555,'','comDev5@dev.com',RSP);

-- Comprobar error noCodeCountry (no se ha introducido el cdigo del pas del programador)
pr_insert_developer ('D55555555','Developer 5','Nombre Rep. Dev5','Apellido Rep. Dev5','555555555D','','Direccin dev5',
                    'ciudad dev5',55555,'Provincia dev5', 555555555,'','comDev5@dev.com',RSP);

-- Comprobar error noHOAddress (no se ha introducido la direccin de la oficina central del programador)
pr_insert_developer ('D55555555','Developer 5','Nombre Rep. Dev5','Apellido Rep. Dev5','555555555D','ES','',
                    'ciudad dev5',55555,'Provincia dev5', 555555555,'','comDev5@dev.com',RSP);

-- Comprobar error noHOCity (no se ha introducido la ciudad de la oficina central del programador)
pr_insert_developer ('D55555555','Developer 5','Nombre Rep. Dev5','Apellido Rep. Dev5','555555555D','ES','Direccin dev5',
                    '',55555,'Provincia dev5', 555555555,'','comDev5@dev.com',RSP);

-- Comprobar error noHOCp (no se ha introducido el cdigo postal de la oficina central del programador)
pr_insert_developer ('D55555555','Developer 5','Nombre Rep. Dev5','Apellido Rep. Dev5','555555555D','ES','Direccin dev5',
                    'ciudad dev5','','Provincia dev5', 555555555,'','comDev5@dev.com',RSP);

-- Comprobar error noHOProvince (no se ha introducido la provincia de la oficina central del programador)
pr_insert_developer ('D55555555','Developer 5','Nombre Rep. Dev5','Apellido Rep. Dev5','555555555D','ES','Direccin dev5',
                    'ciudad dev5',55555,'', 555555555,'','comDev5@dev.com',RSP);

-- Comprobar error noTelephone1 (no se ha introducido el telfono de la oficina central del programador)
pr_insert_developer ('D55555555','Developer 5','Nombre Rep. Dev5','Apellido Rep. Dev5','555555555D','ES','Direccin dev5',
                    'ciudad dev5',55555,'Provincia dev5', '','','comDev5@dev.com',RSP);

-- Comprobar error noHOEmail (no se ha introducido el email de la oficina central del programador)
pr_insert_developer ('D55555555','Developer 5','Nombre Rep. Dev5','Apellido Rep. Dev5','555555555D','ES','Direccin dev5',
                    'ciudad dev5',55555,'Provincia dev5', 555555555,'','',RSP);

-- Comprobar que si el programador est dado de baja se reactiva con los datos nuevos
pr_insert_developer ('D33333333','React Developer 3','Nombre Rep. Dev3','Apellido Rep. Dev3','333333333D','FR','Direccin dev3',
                    'ciudad dev3',33333,'Provincia dev3', 333333333,'','ReaccomDev3@dev.com',RSP);

----------------------------------------------------------------------------------------
-- ########   JUEGO DE PRUEBAS PARA EL PROCEDIMIENTO PR_DELETE_DEVELOPER    ################
----------------------------------------------------------------------------------------

-- Comprobacin del error noDeveloperId (no se ha introducido programador a dar de baja)
pr_delete_developer('', RSP);

-- Comprobacin del error idNoExist (no existe ningn programador con ese id)
pr_delete_developer('D88888888', RSP);

-- Comprobacin del error idDeleted (el programador ya ha sido borrado)
pr_delete_developer('D44444444', RSP);

----------------------------------------------------------------------------------------
-- ########   JUEGO DE PRUEBAS PARA EL PROCEDIMIENTO PR_UPDATE_DEVELOPER    ################
----------------------------------------------------------------------------------------
-- Comprobar Error noDeveloperId (el id del programador a modificar no se ha introducido)
pr_update_developer ('','Developer 2','New Nombre Rep. Dev2','New Apellido Rep. Dev2','322222222D','ES','Direccin dev2',
                    'ciudad dev2',22222,'Provincia dev2', 222222222,'','NewcomDev2@dev.com',RSP);

-- Comprobar Error idNoExist (el id del programador a modificar no existe)
pr_update_developer ('D99999999','Developer 2','New Nombre Rep. Dev2','New Apellido Rep. Dev2','322222222D','ES','Direccin dev2',
                    'ciudad dev2',22222,'Provincia dev2', 222222222,'','NewcomDev2@dev.com',RSP);

-- Comprobar Error idBaja (el programador a modificar est dado de baja)
pr_update_developer ('D44444444','Developer 4','New Nombre Rep. Dev4','New Apellido Rep. Dev2','322222222D','ES','Direccin dev2',
                    'ciudad dev2',22222,'Provincia dev2', 222222222,'','NewcomDev2@dev.com',RSP);

-- Comprobar Error nameComExist (ya existe un programador con el mismo nombre)
pr_update_developer ('D11111111','Developer 2','New Nombre Rep. Dev2','New Apellido Rep. Dev2','322222222D','ES','Direccin dev2',
                    'ciudad dev2',22222,'Provincia dev2', 222222222,'','NewcomDev2@dev.com',RSP);

-- Comprobar Error noNameCom (no se ha introducido nombre de empresa)
pr_update_developer ('D22222222','','New Nombre Rep. Dev2','New Apellido Rep. Dev2','322222222D','ES','Direccin dev2',
                    'ciudad dev2',22222,'Provincia dev2', 222222222,'','NewcomDev2@dev.com',RSP);

-- Comprobar Error noNameLegalR (no se ha introducido el nombre del represetante legal de la empresa)
pr_update_developer ('D22222222','Developer 2','','New Apellido Rep. Dev2','322222222D','ES','Direccin dev2',
                    'ciudad dev2',22222,'Provincia dev2', 222222222,'','NewcomDev2@dev.com',RSP);

-- Comprobar Error noSurnameLegalR (no se ha introducido el apellido del represetante legal de la empresa)
pr_update_developer ('D22222222','Developer 2','New Nombre Rep. Dev2','','322222222D','ES','Direccin dev2',
                    'ciudad dev2',22222,'Provincia dev2', 222222222,'','NewcomDev2@dev.com',RSP);

-- Comprobar error noIdCardR (no se ha introducido el idCard del representante legal del programador)
pr_update_developer ('D22222222','Developer 2','New Nombre Rep. Dev2','New Apellido Rep. Dev2','','ES','Direccin dev2',
                    'ciudad dev2',22222,'Provincia dev2', 222222222,'','NewcomDev2@dev.com',RSP);

-- Comprobar error noCodeCountry (no se ha introducido el cdigo del pas del programador)
pr_update_developer ('D22222222','Developer 2','New Nombre Rep. Dev2','New Apellido Rep. Dev2','322222222D','','Direccin dev2',
                    'ciudad dev2',22222,'Provincia dev2', 222222222,'','NewcomDev2@dev.com',RSP);

-- Comprobar error noHOAddress (no se ha introducido la direccin de la oficina central del programador)
pr_update_developer ('D22222222','Developer 2','New Nombre Rep. Dev2','New Apellido Rep. Dev2','322222222D','ES','',
                    'ciudad dev2',22222,'Provincia dev2', 222222222,'','NewcomDev2@dev.com',RSP);

-- Comprobar error noHOCity (no se ha introducido la ciudad de la oficina central del programador)
pr_update_developer ('D22222222','Developer 2','New Nombre Rep. Dev2','New Apellido Rep. Dev2','322222222D','ES','Direccin dev2',
                    '',22222,'Provincia dev2', 222222222,'','NewcomDev2@dev.com',RSP);

-- Comprobar error noHOCp (no se ha introducido el cdigo postal de la oficina central del programador)
pr_update_developer ('D22222222','Developer 2','New Nombre Rep. Dev2','New Apellido Rep. Dev2','322222222D','ES','Direccin dev2',
                    'ciudad dev2','','Provincia dev2', 222222222,'','NewcomDev2@dev.com',RSP);

-- Comprobar error noHOProvince (no se ha introducido la provincia de la oficina central del programador)
pr_update_developer ('D22222222','Developer 2','New Nombre Rep. Dev2','New Apellido Rep. Dev2','322222222D','ES','Direccin dev2',
                    'ciudad dev2',22222,'', 222222222,'','NewcomDev2@dev.com',RSP);

-- Comprobar error noTelephone1 (no se ha introducido el telfono de la oficina central del programador)
pr_update_developer ('D22222222','Developer 2','New Nombre Rep. Dev2','New Apellido Rep. Dev2','322222222D','ES','Direccin dev2',
                    'ciudad dev2',22222,'Provincia dev2', '','','NewcomDev2@dev.com',RSP);

-- Comprobar error noHOEmail (no se ha introducido el email de la oficina central del programador)
pr_update_developer ('D22222222','Developer 2','New Nombre Rep. Dev2','New Apellido Rep. Dev2','322222222D','ES','Direccin dev2',
                    'ciudad dev2',22222,'Provincia dev2', 222222222,'','',RSP);

END;
/

select * FROM logs WHERE nameProcedure like 'pr_%_developer';