set serveroutput on;
----------------------------------------------------------------------------------------
-- JUEGO DE PRUEBAS PARA PROCEDIMIENTOS DE ABM DEVELOPERS
---------------------------------------------------------------------------------------
DECLARE
	RSP		VARCHAR2(100);
BEGIN

	RSP:= 'OK';

----------------------------------------------------------------------------------------
-- ########   JUEGO DE PRUEBAS PARA EL PROCEDIMIENTO PR_INSERT_APP    ################
----------------------------------------------------------------------------------------
-- Comprobar error noAppIdentif (no se ha introducido nombre de la aplicacin)
pr_insert_app ('','1.1','Android','500x300',300,'linkAppHHH1-1Android','Descripcin de la aplicacin HHH',
                'Espaol','FR',60,'urlVideoHHH-Android','Francs','D11111111',RSP);

-- Comprobar error noVersion (no se ha introducido versin de la aplicacin)
pr_insert_app ('HHH','','Android','500x300',300,'linkAppHHH1-1Android','Descripcin de la aplicacin HHH',
                'Espaol','FR',60,'urlVideoHHH-Android','Francs','D11111111',RSP);

-- Comprobar error noNameOS (no se ha introducido sistema operativo de la aplicacin)
pr_insert_app ('HHH','1.1','','500x300',300,'linkAppHHH1-1Android','Descripcin de la aplicacin HHH',
                'Espaol','FR',60,'urlVideoHHH-Android','Francs','D11111111',RSP);
                
-- Comprobar error noMinResoScreen (no se ha introducido resolucin de la pantalla de la aplicacin)
pr_insert_app ('HHH','1.1','Android','',300,'linkAppHHH1-1Android','Descripcin de la aplicacin HHH',
                'Espaol','FR',60,'urlVideoHHH-Android','Francs','D11111111',RSP);
                
-- Comprobar error noSizeApp (no se ha introducido tamao de la aplicacin)
pr_insert_app ('HHH','1.1','Android','500x300','','linkAppHHH1-1Android','Descripcin de la aplicacin HHH',
                'Espaol','FR',60,'urlVideoHHH-Android','Francs','D11111111',RSP);
                
-- Comprobar error noLink noDescription (no se ha introducido una descripccin en una aplicacin
-- nueva, que no tiene ninguna descripcin)
pr_insert_app ('HHH','1.1','Android','500x300',300,'linkAppHHH1-1Android','',
                'Espaol','FR',60,'urlVideoHHH-Android','Francs','D11111111',RSP);
                
-- Comprobar error noLanguagesDes (no se ha introducido el lenguaje de la descripcin)
pr_insert_app ('HHH','1.1','Android','500x300',300,'linkAppHHH1-1Android','Descripcin de la aplicacin HHH',
                '','FR',60,'urlVideoHHH-Android','Francs','D11111111',RSP);
        
-- Comprobar error noCodeCountry (no se ha introducido cdigo de pas para el precio)
pr_insert_app ('HHH','1.1','Android','500x300',300,'linkAppHHH1-1Android','Descripcin de la aplicacin HHH',
                'Espaol','',60,'urlVideoHHH-Android','Francs','D11111111',RSP);

-- Comprobar error noPrice (no se ha introducido precio)
pr_insert_app ('HHH','1.1','Android','500x300',300,'linkAppHHH1-1Android','Descripcin de la aplicacin HHH',
                'Espaol','FR','','urlVideoHHH-Android','Francs','D11111111',RSP);
                
-- Comprobar error appExist (la aplicacin (app+so+version) ya existe y no est dada de baja)
pr_insert_app ('ABC','1.1','Android','200x300',300,'linkAppABC1-1Android','Descripcin de la aplicacin ABC',
                'Espaol','ES',30,'urlVideoABC-Android','Espaol','D11111111',RSP);

-- Comprobar error  noDevelopers (no se han introducido los programadores)
pr_insert_app ('HHH','1.1','Android','500x300',300,'linkAppHHH1-1Android','Descripcin de la aplicacin HHH',
                'Espaol','FR',60,'urlVideoHHH-Android','Francs','',RSP);
                
-- Comprobar error noLanguageUrl (se ha introducido una urlVideo, pero no el lenguaje de la url)
pr_insert_app ('HHH','1.1','Android','500x300',300,'linkAppHHH1-1Android','Descripcin de la aplicacin HHH',
                'Espaol','FR',60,'urlVideoHHH-Android','','D11111111',RSP);
----------------------------------------------------------------------------------------
-- ########   JUEGO DE PRUEBAS PARA EL PROCEDIMIENTO PR_DELETE_APP    ################
----------------------------------------------------------------------------------------

-- Comprobacin del error noAppIdentif (no se ha introducido programador a dar de baja)
pr_delete_app('','1.1','Android', RSP);

-- Comprobacin del error noVersion (no se ha introducido una versin)
pr_delete_app('ABC','','Android', RSP);

-- Comprobar error  noNameOS (no se ha introducido el sistema operativo)
pr_delete_app('ABC','1.1','', RSP);

-- Comprobar error appNoExist (se ha introducido una applicacin que no existe
--      ya sea el nombre, la versin o el sistema operativo
pr_delete_app('LLL','1.1','Android', RSP);
pr_delete_app('ABC','1.3','Android', RSP);
pr_delete_app('ABC','1.1','ET-Android', RSP);


----------------------------------------------------------------------------------------
-- ########   JUEGO DE PRUEBAS PARA EL PROCEDIMIENTO PR_UPDATE_APP    ################
----------------------------------------------------------------------------------------
-- Comprobar Error noAppIdentif (no se ha introducido aplicacin)
pr_update_app ('','1.1','Android','200x300',300,'NewlinkAppABC1-1Android','N',RSP);

-- Comprobar error noVersion (no se ha introducido versin)
pr_update_app ('ABC','','Android','200x300',300,'NewlinkAppABC1-1Android','N',RSP);

-- Comprobar error noNameOS (no se ha introducido sistema operativo)
pr_update_app ('ABC','1.1','','200x300',300,'NewlinkAppABC1-1Android','N',RSP);

-- Comprobar error noMinResoScreen (no se ha introducido resolucin mnima de pantalla)
pr_update_app ('ABC','1.1','Android','',300,'NewlinkAppABC1-1Android','N',RSP);

-- Comprobar error noSizeApp (no se ha introducido tamao de la aplicacin)
pr_update_app ('ABC','1.1','Android','200x300','','NewlinkAppABC1-1Android','N',RSP);

-- Comprobar error noLink (no se ha introducido link de la aplicacin)
pr_update_app ('ABC','1.1','Android','200x300',300,'','N',RSP);

-- Comprobar error noActive (no se ha introducido si est activo o no)
pr_update_app ('ABC','1.1','Android','200x300',300,'NewlinkAppABC1-1Android','',RSP);

-- Comprobar error appNoExist (no existe la aplicacin introducida, nombre, versin o sistema operativo)
pr_update_app ('LLL','1.1','Android','200x300',300,'NewlinkAppABC1-1Android','N',RSP);
pr_update_app ('ABC','1.3','Android','200x300',300,'NewlinkAppABC1-1Android','N',RSP);
pr_update_app ('ABC','1.1','TA-Android','200x300',300,'NewlinkAppABC1-1Android','N',RSP);

-- Comprobar error versionPostApp (exite una versin posterior a la que se quiere activar)
-- primero insertamos una aplicacin nueva y despus intentaremos activar la versin anterior
pr_insert_app ('ABC','1.3','Android','200x300',300,'linkAppABC1-2Android','Descripcin de la aplicacin ABC',
                'Espaol','ES',30,'','','D11111111,D22222222',RSP);
pr_update_app ('ABC','1.2','Android','200x300',300,'linkAppABC1-2Android','S',RSP);

END;
/

select * FROM logs WHERE nameProcedure like 'pr_%_app';