set serveroutput on;
----------------------------------------------------------------------------------------
-- JUEGO DE PRUEBAS PARA PROCEDIMIENTOS DE ABM PRECIOS
---------------------------------------------------------------------------------------
DECLARE
	RSP		VARCHAR2(100);
BEGIN

	RSP:= 'OK';
----------------------------------------------------------------------------------------
-- ########   JUEGO DE PRUEBAS CONTROL ERRORES DE ENTRADA DE DATOS    ################
----------------------------------------------------------------------------------------
 -- Comprobar error noAction (no se introduce accin a realizar)
 pr_abm_prices('','ABC','Android','1.1','FR', 60, RSP);
 pr_abm_prices('T','ABC','Android','1.1','FR', 60, RSP);
 
 -- Comprobar error noAppIdentif (no se ha introducido aplicacin)
 pr_abm_prices('A','','Android','1.1','FR', 60, RSP);
 
 -- Comprobar error noVersion (no se ha introducido versin de la aplicacin)
 pr_abm_prices('A','ABC','Android','','FR', 60, RSP);
 
 -- Comprobar error noNameOS (no se ha introducido aplicacin)
 pr_abm_prices('A','ABC','','1.1','FR', 60, RSP);
 
 -- Comprobar error noCodeCountry (no se ha introducido cdigo del pas)
  pr_abm_prices('A','ABC','Android','1.1','', 60, RSP);
 
   
 ----------------------------------------------------------------------------------------
-- ########   JUEGO DE PRUEBAS ALTA DE PRECIOS    ################
----------------------------------------------------------------------------------------  
-- Comprobar error noPrice (no se ha introducido un precio)
 pr_abm_prices('A','ABC','Android','1.1','FR', '', RSP);
 
-- Comprobar error noAppInsert (no se ha dado de alta la aplicacin a la que hacer referencia)
 pr_abm_prices('A','LLL','Android','1.1','FR', 60, RSP);

-- Comprobar error priceExist (ya existe un precio para esa aplicacinn, versin, so y pas)
 pr_abm_prices('A','ABC','Android','1.1','ES', 60, RSP);
 

 ----------------------------------------------------------------------------------------
-- ########   JUEGO DE PRUEBAS BAJA DE PRECIOS    ################
----------------------------------------------------------------------------------------  
 -- Comprobar error priceNoExist (el precio a dar de baja no existe)
 pr_abm_prices('B','ABC','Android','1.1','FR', 60, RSP);
  
----------------------------------------------------------------------------------------
-- ########   JUEGO DE PRUEBAS MODIFICACIN DE PRECIOS    ################
----------------------------------------------------------------------------------------  
-- Comprobar error priceNoExist (el precio a dar de baja no existe)
 pr_abm_prices('M','ABC','Android','1.1','FR', 60, RSP);

-- Comprobar error noPrice (no se ha introducido un precio)
 pr_abm_prices('M','ABC','Android','1.1','FR', '', RSP);
 


END;
/

select * FROM logs WHERE nameProcedure like 'pr_%_prices';